'Debug 8503
'=====================================================================
'{ACERCA DE IDEALEDIT}
'{ABOUT IDEALEDIT}
'=====================================================================
'IdealEdit by Angel Berbel,2012
'IdealEdit es libre y de cdigo abierto
'IdealEdit is free and open source 
'IdealEdit pretender ser una grata experiencia y un ejemplo de programacin
'IdealEdit intended to be a pleasant experience and a programming example
'=====================================================================
'{RECURSOS}
'====================================================================
Resource BMP_Bienvenida as "\recursos\bienvenida.bmp"
Resource BMP_Nuevo as "\Recursos\nuevo16x16.bmp"
Resource BMP_Abrir as "\Recursos\Abrir16x16.bmp"
'======================================================================
'{DECLARACIONES API}
'======================================================================
Declare SendMessageAPI as "SendMessageA" of "user32"
  hWnd as long
  wMsg as long
  wParam as long
  lParam as long
  Result as long
End Declare
Declare WaitForSingleObjectAPI as  "WaitForSingleObject" of "kernel32"
  hHandle As Long
  dwMilliseconds As Long
  result as long
End Declare
Declare HtmlHelpAPI as "HtmlHelpA" of "hhctrl.ocx"
  hwnd As Long
  pszFile As String
  uCommand As Long
  dwData As Long
End Declare
Declare getscrollposAPI as "GetScrollPos" of "user32.dll" 
  hWnd As Integer
  nBar As Integer
  result as integer
end declare

'======================================================================
'{CONSTANTES Y VARIABLES GLOBALES}
'======================================================================
const SB_VERT=1
const WM_VSCROLL=&H115
Const SB_THUMBPOSITION = 4

Const EM_SETMARGINS=&HD3
Const EC_LEFTMARGIN=&H1
Const EC_RIGHTMARGIN=&H2
Const EM_LINEFROMCHAR =&HC9 
Const EM_LINELENGTH = &HC1
Const EM_LINEINDEX=&HBB
const EM_HIDESELECTION = 1087

const clCadenas=&H0C8000
Const clComentario=&H0000FF
Const clOperadores=&HFF00FF
const clNumeros=&H1A4EA1
Const clPalabras=&HFF0000
Const clPalabras2=&HFFA500

Const clGris=&H808080
Const clRojo=&H0000FF
Const clNegro=&H000000
Dim expandirLibre as boolean
Dim rchModificado1 as boolean
Dim rchModificado2 as boolean
Dim rutaArchivo(2) as string
Dim NombreArchivo(2) as string
Dim lineaInicial as integer
Dim lineaFinal as integer
Dim lineasFavoritas(2,10) as string
Dim numLinea as Long,iniSeleccion as Long, posicion as Long, anteriorPrimerCaracter as Long,longitudLinea as Long, primerCaracter as Long, previoPrimercaracter as long,posicionPrevia as Long

'======================================================================
'{ARCHIVOS INI}
'======================================================================

Dim iniConfig as iniFile
  iniconfig.open (exepath+"idealEdit.ini")
Dim iniLeng as iniFile
  Select case ucase$(iniconfig.readstr("Idiomas\Lenguaje"))
    Case "INGLES" 
      iniLeng.Open (exepath+"Ingles.lng")
    Case "FRANCES"
      'no incluido
      'iniLeng.Open (exepath+"Frances.lng")
    Case else
      iniLeng.Open (exepath+"Espaol.lng")
  End Select

'========================================================================================
'{OBJETOS DIM}
'========================================================================================
Dim fleDialogo as Filedialog
Dim fleStream as FileStream

Dim btmTabEditor as Bitmap
btmTabEditor.Transparent=True
btmtabEditor.TransparentMode=TmAuto
btmTabEditor.loadFromFile(exePath+"\Recursos\Nuevo16x16.bmp")
Dim fntEditor as Font
  With fntEditor
    name="fixedsys"
    size=10
  End with
Dim appAplicacion as application
Dim btmBienvenida as Bitmap
btmBienvenida.loadFromResource(BMP_Bienvenida)
dim hasReservadas1 as hashtable
dim hasReservadas2 as hashtable

dim c as integer
'if fileexists("keywords.lst")=false then showmessage "keywords.lst not found"
fleStream.open("keywords.lst")
hasReservadas1.size=fleStream.linecount*2
for c=1 to fleStream.linecount
  hasReservadas1.put(fleStream.readline)
next c
fleStream.close
fleStream.open("Propiedades.lst")
hasReservadas2.size=fleStream.linecount*2
for c=1 to fleStream.linecount
  hasReservadas2.put(fleStream.readline)
next c
fleStream.close
Dim tmrSintaxis as wintimer
tmrSintaxis.interval=10
tmrSintaxis.ontimer=tmrSintaxis_Ontimer 
dim tmrNumeracion as wintimer
tmrNumeracion.interval=40
tmrNumeracion.ontimer=tmrNumeracion_Ontimer

'========================================================================================
'{GUI}
'========================================================================================
appicon="icono.ico"
Object frmBienvenida as Form
  Caption="IdealEdit"
  Center
  Shape(btmBienvenida)
End Object
frmBienvenida.show
frmBienvenida.repaint
sleep 2000
frmBienvenida.closeForm
Object frmEspera as form
  Caption=iniLeng.readstr("formEspera\captionForm")
  center
  'stayontop=true
  borderStyle=bsDialog
  object lblEspera as label
    caption=iniLeng.readstr("formEspera\captionEtiqueta")
    left=frmespera.clientWidth/2-frmespera.canvas.textwidth(lblEspera.caption)/2
    Top=30
  End object
  object pgrEspera as Progressbar
    top=frmEspera.Clientheight/2
    left=frmespera.clientWidth/2-(pgrEspera.width/2)
    position=1
  End object
End object
'----------------------------------------------------------------------------------->FrmPrincipal
Object frmPrincipal As Form
  Caption="IdealEdit"
  Height=480
  Width=665
  'BorderIcons=1
  'BorderStyle=1
  Center
  'Otros objetos
  Object staEstado As Statusbar
    Simpletext=false
    SizeGrip=True
    Addpanel
    Addpanel
    Panelwidth(0)=150
  End Object

'------------------------------------------------------------------------------------>MEN
  Object mnuPrincipal as Mainmenu
    Object mnuArchivo as Menuitem
      Caption= inileng.readStr("Menu\Archivo")
      Object mnuNuevo as Menuitem
        Tag=0
        Caption=iniLeng.ReadStr("Menu\Nuevo")
        shortcut="CTRL+N"
        bmpResource(BMP_nuevo)
        Onclick=Menu_OnClick
      End object
      Object mnuAbrir as Menuitem
        Tag=1
        Caption=iniLeng.ReadStr("Menu\Abrir")
        shortcut="CTRL+O"
        bmpResource(BMP_Abrir)
        Onclick=Menu_OnClick
      end object
      Object mnuAbrirRecientes as Menuitem
        'Tag=1
        Caption=iniLeng.ReadStr("Menu\AbrirRecientes")
        'shortcut="CTRL+O"
        'bmpResource(resource)
        'Onclick=Menu_OnClick
       Object mnuRecientes1 as Menuitem
          Tag=2
          Caption="..."
          'shortcut="CTRL+O"
         'bmpResource(resource)
         'Onclick=Menu_OnClick
        end object
        Object mnuRecientes2 as Menuitem
          Tag=3
          Caption="..."
          'shortcut="CTRL+O"
         'bmpResource(resource)
         'Onclick=Menu_OnClick
        end object
         Object mnuRecientes3 as Menuitem
          Tag=4
          Caption="..."
          'shortcut="CTRL+O"
         'bmpResource(resource)
         'Onclick=Menu_OnClick
        end object
        Object mnuRecientes4 as Menuitem
          Tag=5
          Caption="..."
          'shortcut="CTRL+O"
         'bmpResource(resource)
         'Onclick=Menu_OnClick
        end object
      End Object
      Object mnuGuardar as Menuitem
        Tag=6
        Caption=iniLeng.ReadStr("Menu\Guardar")
        shortcut="CTRL+S"
        'bmpResource(resource)
        Onclick=Menu_OnClick
      end object
      Object mnuGuardarComo as Menuitem
        Tag=7
        Caption=iniLeng.ReadStr("Menu\GuardarComo")
        'shortcut="CTRL+S"
        'bmpResource(resource)
        Onclick=Menu_OnClick
      end object
      Object mnuSeparador1 as Menuitem
         Caption="-"
      End Object
      Object mnuImprimir as Menuitem
        Tag=8
        Caption=iniLeng.ReadStr("Menu\Imprimir")
        Shortcut="CTRL+P"
        'bmpResource(resource)
        Onclick=Menu_OnClick
      end object
      Object mnuSeparador2 as Menuitem
         Caption="-"
      End Object
      Object mnuSalir as Menuitem
        Tag=9
        Caption=iniLeng.ReadStr("Menu\Salir")
        Shortcut="CTRL+E"
        'bmpResource(resource)
        Onclick=Menu_OnClick
      end object
    end object
    Object mnuEdicion as Menuitem
      Caption=iniLeng.ReadStr("Menu\Edicion")
      Object mnuDeshacer as Menuitem
        Tag=10
        Caption=iniLeng.ReadStr("Menu\Deshacer")
        Shortcut="CTRL+Z"
        'bmpResource(resource)
        Onclick=Menu_OnClick
      end object
      Object mnuCortar as Menuitem
        Tag=11
        Caption=iniLeng.ReadStr("Menu\Cortar")
        Shortcut="CTRL+X"
        'bitmap.LoadFromResource("cutXP.bmp")
        'bmpResource(Resource)
        Onclick=Menu_OnClick
      end object
      Object mnuCopiar as Menuitem
        Tag=12
        Caption=iniLeng.ReadStr("Menu\Copiar")
        Shortcut="CTRL+C"
        'bmpResource(resource)
        Onclick=Menu_OnClick
      end object
      Object mnuPegar as Menuitem
        Tag=13
        Caption=iniLeng.ReadStr("Menu\Pegar")
        Shortcut="CTRL+V"
        'bmpResource(resource)
        Onclick=Menu_OnClick
      end object
      Object mnuSeparador3 as Menuitem
         Caption="-"
      End Object
      Object mnuSeleccionarTodo as Menuitem
        Tag=14
        Caption=iniLeng.ReadStr("Menu\SeleccionarTodo")
        Shortcut="CTRL+A"
        'bmpResource(resource)
        Onclick=Menu_OnClick
      end object
      Object mnuComentar as Menuitem
        Tag=15
        Caption=iniLeng.ReadStr("Menu\Comentar")
        'Shortcut="CTRL+V"
        'bmpResource(resource)
        Onclick=Menu_OnClick
      end object
      Object mnuQuitarLineasVacias as Menuitem
        Tag=16
        Caption=iniLeng.ReadStr("Menu\QuitarLineasVacias")
        'Shortcut="CTRL+V"
        'bmpResource(resource)
        Onclick=Menu_OnClick
      end object
      Object mnuBorrarLinea as Menuitem
        Tag=17
        Caption=iniLeng.ReadStr("Menu\BorrarLinea")
        'Shortcut="CTRL+V"
        'bmpResource(resource)
        Onclick=Menu_OnClick
      end object
      Object mnufavoritos as Menuitem
        Tag=18
        Caption=iniLeng.ReadStr("Menu\favoritas")

        'Shortcut="CTRL+V"
        'bmpResource(resource)
        Onclick=Menu_OnClick
      end object

      Object mnuSeparador4 as Menuitem
         Caption="-"
      End Object
      Object mnuPreferencias as Menuitem
        Tag=19
        Caption=iniLeng.ReadStr("Menu\Preferencias")
        'Shortcut="CTRL+V"
        'bmpResource(resource)
        'Onclick=Menu_OnClick
      end object
    end object
    Object mnuBuscar as Menuitem
      Caption=iniLeng.ReadStr("Menu\Buscar")
      Object mnuBuscarReemplazar as Menuitem
        Tag=20
        Caption=iniLeng.ReadStr("Menu\BuscarReemplazar")
        Shortcut="CTRL+F"
        'bmpResource(resource)
        Onclick=Menu_OnClick
      end object
      Object mnuIrLinea as Menuitem
        Tag=21
        Caption=iniLeng.ReadStr("Menu\Irlinea")
        Shortcut="CTRL+G"
        'bmpResource(resource)
        'Onclick=Menu_OnClick
      end object
    End Object
    Object mnuEjecutar as Menuitem
      Caption=iniLeng.ReadStr("Menu\Ejecutar")
      Object mnuCompilar as Menuitem
        Tag=22
        Caption=iniLeng.ReadStr("Menu\Compilar")
        'Shortcut="CTRL+F"
        'bmpResource(resource)
        Onclick=Menu_OnClick
      end object
      Object mnuCompilarEjecutar as Menuitem
        Tag=23
        Caption=iniLeng.ReadStr("Menu\CompilarEjecutar")
        Shortcut="F9"
        'bmpResource(resource)
        Onclick=Menu_OnClick
      end object
    End object
    Object mnuAyuda as Menuitem
      Caption=iniLeng.ReadStr("Menu\Ayuda")
      Object mnuFNXAyuda as Menuitem
        Tag=24
        Caption=iniLeng.ReadStr("Menu\AyudaFNX")
        Shortcut="F1"
        'bmpResource(resource)
        Onclick=Menu_OnClick
      end object
      Object mnuAyudaEditor as Menuitem
        Tag=25
        Caption=iniLeng.ReadStr("Menu\AyudaEditor")
        'Shortcut="F9"
        'bmpResource(resource)
        'Onclick=Menu_OnClick
      end object
      Object mnuAcercaDe as Menuitem
        Tag=26
        Caption=iniLeng.ReadStr("Menu\AcercaDe")
        'Shortcut="F9"
        'bmpResource(resource)
        'Onclick=Menu_OnClick
      end object
    End Object
  End Object
'--------------------------------------------------------------------------->FIN MEN
'--------------------------------------------------------------------->PANEL SUPERIOR
  Object pnlSuperior as Panel
    Align=altop
    Bevelinner =1
    Height=30
    OnmouseMove=autoOcultar_OnMouseMove

    Object btnFaceNuevo as facebutton
      Tag=100
      Left=10
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.readStr("barra superior\HintNuevo")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\Nuevo.bmp")
      OnClick=pnlSuperior_OnClick
    End Object
    Object btnFaceAbrir as facebutton
      Tag=101
      Left=38
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.ReadStr("Barra Superior\HintAbrir")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\Abrir.bmp")
      OnClick=pnlSuperior_OnClick
    End Object
    Object btnFaceGuardar as facebutton
      Tag=102
      Left=66
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.ReadStr("Barra Superior\HintGuardar")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\Guardar.bmp")
      OnClick=pnlSuperior_OnClick
    End Object
    Object btnFaceImprimir as facebutton
      Tag=103
      Left=94
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.ReadStr("Barra Superior\HintImprimir")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\imprimir.bmp")
      OnClick=pnlSuperior_OnClick
    End Object
    Object imgSeparador1 as image
      Top=2
      Left=122
      Width=3
      height=26
      'Transparent=True
      canvas.line(1,3,1,26,clGris)
    End object
    Object btnFaceDeshacer as facebutton
      Tag=104
      Left=130
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.ReadStr("Barra Superior\HintDeshacer")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\Deshacer.bmp")
      OnClick=pnlSuperior_OnClick
    End Object
    Object btnFaceCortar as facebutton
      Tag=105
      Left=158
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.ReadStr("Barra Superior\HintCortar")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\Cortar.bmp")
      OnClick=pnlSuperior_OnClick
    End Object
    Object btnFaceCopiar as facebutton
      Tag=106
      Left=186
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.ReadStr("Barra Superior\HintCopiar")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\Copiar.bmp")
      OnClick=pnlSuperior_OnClick
    End Object
    Object btnFacepegar as facebutton
      Tag=107
      Left=214
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.ReadStr("Barra Superior\HintPegar")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\Pegar.bmp")
      OnClick=pnlSuperior_OnClick
    End Object
    Object imgSeparador2 as image
      Top=2
      Left=242
      Width=3
      height=26
      'Transparent=True
      canvas.line(1,3,1,26,clGris)
    End object
    Object btnFaceBuscar as facebutton
      Tag=108
      Left=250
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.ReadStr("Barra Superior\HintBuscar")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\Buscar.bmp")
      OnClick=pnlSuperior_OnClick
    End Object
    Object imgSeparador3 as image
      Top=2
      Left=278
      Width=3
      height=26
      'Transparent=True
      canvas.line(1,3,1,26,clGris)
    End object
    Object btnFaceEjecutar as facebutton
      Tag=109
      Left=286
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.ReadStr("Barra Superior\HintEjecutar")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\Ejecutar.bmp")
      OnClick=pnlSuperior_OnClick
    End Object
    Object imgSeparador4 as image
      Top=2
      Left=314
      Width=3
      height=26
      'Transparent=True
      canvas.line(1,3,1,26,clGris)
    End object
    Object btnFaceAyudaFNX as facebutton
      Tag=110
      Left=322
      Top=3
      Width=26
      Height=26
      Flat=true
      Cursor=-21
      Hint=iniLeng.ReadStr("Barra Superior\HintAyudaFNX")
      ShowHint=True
      Bitmap.loadfromfile(exepath+"\Recursos\Ayuda.bmp")
      OnClick=pnlSuperior_OnClick
    End Object
  End object
'--------------------------------------------------------------->FIN PANEL SUPERIOR
'--------------------------------------------------------------->PANEL IZQUIERDO
   Object pnlIzquierdo as Panel
     Align=alleft
     Bevelinner =2
     Width=380
     Object btnAutoOcultar as Button
       'Tag=109
       Left=3
       Top=3
       Width=26
       Height=26
       Cursor=-21
       Hint=iniLeng.ReadStr("Barra Izquierda\HintFijar")
       ShowHint=True
       Bitmap.loadfromfile(exepath+"\Recursos\Fijo.bmp")
       OnClick=AutoOcultar_OnClick
     End Object
     Object imgTitulo as image
       left=90
       Top=5
       width=285
       Height=30
       Canvas.rectangle(0,0,285,30,clGris)
       Canvas.fill(1,1,clrojo,clnegro)
     end object
     Object btnFaceHerramientas as facebutton
       Tag=200
       Left=5
       Top=60
       Width=80
       Height=50
       Caption=iniLeng.ReadStr("Barra Izquierda\CaptionHerramientas")
       Flat=true
       Cursor=-21
       Hint=iniLeng.ReadStr("Barra Izquierda\HintHerramientas")
       ShowHint=True
       Layout=BlGlyphTop
       Bitmap.loadfromfile(exepath+"\Recursos\Herramientas.bmp")
       OnClick=panelIzquierdo_OnClick
     End Object
     Object btnFaceNotas as facebutton
       Tag=201
       Left=5
       Top=115
       Width=80
       Height=50
       Caption=iniLeng.ReadStr("Barra Izquierda\CaptionNotas")
       Flat=true
       Cursor=-21
       Hint=iniLeng.ReadStr("Barra Izquierda\HintNotas")
       ShowHint=True
       Layout=BlGlyphTop
       Bitmap.loadfromfile(exepath+"\Recursos\Notas.bmp")
       OnClick=panelIzquierdo_OnClick
     End Object
    Object btnFaceCalculadora as facebutton
       Tag=202
       Left=5
       Top=170
       Width=80
       Height=50
       Caption=iniLeng.ReadStr("Barra Izquierda\CaptionCalculadora")
       Flat=true
       Cursor=-21
       Hint=iniLeng.ReadStr("Barra Izquierda\HintCalculadora")
       ShowHint=True
       Layout=BlGlyphTop
       Bitmap.loadfromfile(exepath+"\Recursos\Calculadora.bmp")
       OnClick=panelIzquierdo_OnClick
     End Object
     Object btnFaceColores as facebutton
       Tag=203
       Left=5
       Top=225
       Width=80
       Height=50
       Caption=iniLeng.ReadStr("Barra Izquierda\CaptionColores")
       Flat=true
       Cursor=-21
       Hint=iniLeng.ReadStr("Barra Izquierda\HintColores")
       ShowHint=True
       Layout=BlGlyphTop
       Bitmap.loadfromfile(exepath+"\Recursos\Colores.bmp")
       OnClick=panelIzquierdo_OnClick
     End Object

     Object btnFaceKeyCodes as facebutton
       Tag=204
       Left=5
       Top=280
       Width=80
       Height=50
       Caption=iniLeng.ReadStr("Barra Izquierda\CaptionCodigos")
       Flat=true
       Cursor=-21
       Hint=iniLeng.ReadStr("Barra Izquierda\HintCodigos")
       ShowHint=True
       Layout=BlGlyphTop
       Bitmap.loadfromfile(exepath+"\Recursos\Caracter.bmp")
       OnClick=panelIzquierdo_OnClick
     End Object
'-------------------------------------->panel Herramientas
     Object pnlHerramientas as Panel
       Top=40
       left=90
       width=285
       Height=screenheight-160                   '918
       BevelInner=1
       Object grpObjetos as Groupbox
         Top=5
         left=5
         width=pnlHerramientas.Width-10
         Height=400
         Caption=iniLeng.ReadStr("Panel Izquierdo\CaptionObjetos")
         Object lblSangria as label
           Left=5
           Top=15
           Width=90
           Caption=iniLeng.ReadStr("Panel Izquierdo\CaptionSangria")
           Transparent=True
         End Object
         Object edtSangria as Edit
           Top=15
           Left=95
           Width=30
           Text="1"
         End Object
         Object btnFlechaArriba as Button
            Tag=250
            left=128
            Top=15
            Width=25
            Height=12
            Hint=iniLeng.ReadStr("Panel Izquierdo\HintFlechaArriba")
            ShowHint=True
            Cursor=-21
            Bitmap.LoadFromFile(exepath+"\Recursos\FlechaArriba.bmp")
            Onclick=btnSangria_OnClick
         End Object
         Object btnFlechaAbajo as Button
            tag=251
            left=128
            Top=27
            Width=25
            Height=12
            Hint=iniLeng.ReadStr("Panel Izquierdo\HintFlechaAbajo")
            ShowHint=True
            Cursor=-21
            Bitmap.LoadFromFile(exepath+"\Recursos\FlechaAbajo.bmp")
            Onclick=btnSangria_OnClick
         End Object
         Object btnPrdeterminado as Button
            Tag=252
            left=158
            Top=15
            Width=110
            Height=20
            Caption=iniLeng.ReadStr("Panel Izquierdo\CaptionValorInicial")
            Cursor=-21
            Hint=iniLeng.ReadStr("Panel Izquierdo\HintValorInicial")
            ShowHint=True
            'Bitmap.LoadFromFile(exepath+"\Recursos\FlechaAbajo.bmp")
            Onclick=btnSangria_OnClick
         End Object
         Object tabObjetos as tabControl
           Top=50
           Left=5
           Width=grpObjetos.Width-10
           Height=grpObjetos.Height-55
           addTab(iniLeng.Readstr("Panel Izquierdo\CaptionVisibles"))
           AddTab(iniLeng.Readstr("Panel Izquierdo\CaptionNoVisibles"))
           AddTab(iniLeng.Readstr("Panel Izquierdo\CaptionDialogos"))
           OnChange=tabObjetos_OnChange
           Object pnlVisibles as panel
             align=alclient
             Object btnfaceBoton as facebutton
               Tag=301
                Left=5
                Top=10
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintButton")
                ShowHint=True
                NumBmp=1
                Bitmap.loadfromfile(exepath+"\Recursos\Boton.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnfaceCheckListBox as facebutton
               Tag=302
                Left=36
                Top=10
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintCheckListBox")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\CheckListBox.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnfaceCheckBox as facebutton
               Tag=303
                Left=67
                Top=10
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintCheckbox")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\CheckBox.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnfaceComboBox as facebutton
               Tag=304
                Left=98
                Top=10
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintCombobox")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\ComboBox.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnfaceDateTime as facebutton
               Tag=305
                Left=129
                Top=10
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintDateTimePick")

                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\datetimepicker.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnfaceEdit as facebutton
               Tag=306
                Left=160
                Top=10
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintEdit")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\edit.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnfaceFaceButton as facebutton
               Tag=307
                Left=191
                Top=10
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintFaceButton")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\FaceButton.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnfaceForm as facebutton
               Tag=308
                Left=222
                Top=10
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintForm")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\Form.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnfaceGroupBox as facebutton
               Tag=309
                Left=5
                Top=41
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintGroupBox")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\groupbox.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnfaceImage as facebutton
               Tag=310
                Left=36
                Top=41
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintImage")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\Image.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnfaceLabel as facebutton
               Tag=311
                Left=67
                Top=41
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintLabel")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\Label.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnfaceListBox as facebutton
               Tag=312
                Left=98
                Top=41
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintListBox")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\ListBox.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnfaceListView as facebutton
               Tag=313
                Left=129
                Top=41
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintListView")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\ListView.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnfaceMainMenu as facebutton
               Tag=314
                Left=160
                Top=41
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintMainmenu")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\Mainmenu.bmp")
                OnClick=Objetos_OnClick
             End Object

             Object btnFacePanel as facebutton
               Tag=315
                Left=191
                Top=41
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintPanel")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\Panel.bmp")
                OnClick=Objetos_OnClick
             End Object
              Object btnFacePopupMenu as facebutton
               Tag=316
                Left=222
                Top=41
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintPopupmenu")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\PopupMenu.bmp")
                OnClick=Objetos_OnClick
             End Object

             Object btnfaceProgressBar as facebutton
               Tag=317
                Left=5
                Top=72
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintProgressBar")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\ProgressBar.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnFaceradioButton as facebutton
               Tag=253
                Left=36
                Top=72
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintradioButton")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\radioButton.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnFaceRichedit as facebutton
               Tag=319
                Left=67
                Top=72
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintRichedit")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\richedit.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnFaceSplitter as facebutton
               Tag=320
                Left=98
                Top=72
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintSplitter")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\Splitter.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnFaceStatusBar as facebutton
               Tag=321
                Left=129
                Top=72
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintStatusBar")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\statusBar.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnFaceStringGrid as facebutton
               Tag=322
                Left=160
                Top=72
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintStringGrid")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\stringGrid.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnFaceTabControl as facebutton
               Tag=323
                Left=191
                Top=72
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintTabControl")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\TabControl.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnFaceTrackBar as facebutton
               Tag=324
                Left=222
                Top=72
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintTrackBar")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\TrackBar.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnFaceTreeview as facebutton
               Tag=325
                Left=5
                Top=103
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintTreeview")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\treeview.bmp")
                OnClick=Objetos_OnClick
             End Object
           end object
           Object pnlNoVisibles as Panel
             align=alclient
             Visible=False
            Object lstNoVisibles as Listbox
               Top=5
               Left=5
               Width=pnlNoVisibles.Width-10
               Height=pnlNoVisibles.Height-10
               AddItem "Application"
               AddItem "Bitmap"
               AddItem "Canvas"
               AddItem "Clientsocket"
               AddItem "FileStream"
               AddItem "Font"
               AddItem "HashTable"
               AddItem "Inifile"
               AddItem "MemorySream"
               AddItem "Printer"
               AddItem "RandomFile"
               AddItem "Registry"
               AddItem "ServerSocket"
               AddItem "Printer"
               AddItem "WinTimer"
               itemIndex=0
             End Object
           end object
           Object pnlDialogos as Panel
             align=alclient
             Visible=false
             Object btnfaceFileDialog as facebutton
               Tag=301
                Left=5
                Top=10
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintFileDialogo")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\FileDialogo.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnfaceFontDialog as facebutton
               Tag=302
                Left=36
                Top=10
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintFontDialogo")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\FontDialogo.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnfaceColorDialog as facebutton
               Tag=303
                Left=67
                Top=10
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintColorDialogo")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\ColorDialogo.bmp")
                OnClick=Objetos_OnClick
             End Object
             Object btnfacePrintDialog as facebutton
               Tag=304
                Left=98
                Top=10
                Width=26
                Height=26
                Flat=true
                Cursor=-21
                Hint=iniLeng.ReadStr("Panel Izquierdo\HintColorDialogo")
                ShowHint=True
                Bitmap.loadfromfile(exepath+"\Recursos\PrintDialogo.bmp")
                OnClick=Objetos_OnClick
             End Object

           end object
         End Object
       End object
       Object grpMacros as Groupbox
         Top=10+grpObjetos.Height
         left=5
         width=pnlHerramientas.Width-10
         Height=(pnlHerramientas.Height- grpObjetos.Height ) -15                   '500
         Caption=iniLeng.ReadStr("Panel Izquierdo\CaptionMacros")
         Object lstMacros as Listbox
           Top=15
           Left=5
           Width=grpMacros.Width-10
           Height=grpMacros.Height-20
           AddItem "For...Next"
           AddItem "Do...Loop Until"
           AddItem "..............."
           AddItem "Etc"
           itemIndex=0
         End Object
       End object
     End object
'------------------------------------->Fin panel Herramientas
     Object grpNotas as Groupbox
       Top=40
       left=90
       width=285
       Height=screenheight-160 
       Visible=False
     End object
     Object grpCalculadora as Groupbox
       Top=40
       left=90
       width=285
       Height=screenheight-160 
       Visible=False
     End object
     Object grpColores as Groupbox
       Top=40
       left=90
       width=285
       Height=screenheight-160 
       Visible=False
     End object
     Object grpCodigos as Groupbox
       Top=40
       left=90
       width=285
       Height=screenheight-160 
       Visible=False
     End object

   End Object
'-------------------------------------------------------------->FIN PANEL IZQUIERDO
'-------------------------------------------------------------->PANEL CENTRAL
   Object pnlCentral as Panel
     Align=alClient
     Object lstSubFun as Listbox
       Width=200
       align=alRight
       Sorted=True
       Onclick=lstSubFun_OnClick
     End Object
     Object splSplitter as Splitter
       Width=3
       Align=alright
     End Object
     Object pnlCentroSuperior1 as Panel
       Align=alTop
       Height=30
       OnmouseMove=autoOcultar_OnMouseMove
       Object lblBusquedaRapida as label
         Left=5
         Top=4
         Width=75
         Caption=iniLeng.readStr("Barras CentroSuperiores\CaptionBusquedaRapida")
         Transparent=True
       End Object
       Object edtBusquedaRapida as Edit
         Top=4
         Left=85
         Width=75
         'autoselect=true
       End Object
       Object btnBusquedaRapida as Button
         Top=4
         Width=75
         Height=20
         Left=165
         Caption=iniLeng.readStr("Barras CentroSuperiores\CaptionBuscar")
         Hint=iniLeng.readStr("Barras CentroSuperiores\HintBuscar")
         Showhint=True
         Cursor=-21
         Onclick=BusquedaRapida_OnClick
       End Object
       Object btnBusquedaSiguiente as Button
         Top=4
         Width=75
         Height=20
         Left=245
         Caption=iniLeng.readStr("Barras CentroSuperiores\CaptionSiguiente")
         Hint=iniLeng.readStr("Barras CentroSuperiores\HintSiguiente")
         ShowHint=True
         Cursor=-21
         Onclick=busquedaRapidaSiguiente_OnClick

       End Object
       Object lblIrLinea as label
         Left=325
         Top=4
         Width=75
         Caption=iniLeng.readStr("Barras CentroSuperiores\LabelIr")
         Transparent=True
       End Object
       Object edtIrLinea as Edit
         Top=4
         Left=405
         Width=75
       End Object
       Object btnIrLinea as Button
         Top=4
         Width=75
         Height=20
         Left=485
         Caption=iniLeng.readStr("Barras CentroSuperiores\CaptionIr")
         Hint=iniLeng.readStr("Barras CentroSuperiores\HintIr")
         ShowHint=True
         Cursor=-21
         Onclick=IrLinea_OnClick
       End Object
       Object btnPrimeraLinea as Button
         Top=4
         Width=75
         Height=20
         Left=565
         Caption=iniLeng.readStr("Barras CentroSuperiores\CaptionPrimeraLinea")
         Hint=iniLeng.readStr("Barras CentroSuperiores\HintPrimeraLinea")
         ShowHint=true
         Cursor=-21
         Onclick=IrPrimeraLinea_OnClick
       End Object
       Object btnUltimaLinea as Button
         Top=4
         Width=75
         Height=20
         Left=645
         Caption=iniLeng.readStr("Barras CentroSuperiores\CaptionUltimaLinea")
         Hint=iniLeng.readStr("Barras CentroSuperiores\HintUltimaLinea")
         ShowHint=True
         Cursor=-21
         OnClick=IrUltimaLinea_OnClick
       End Object

     End object
     Object pnlCentroSuperior2 as Panel
       Align=alTop
       Height=30
       OnmouseMove=autoOcultar_OnMouseMove
       Object lblObjetos as label
         Left=5
         Top=4
         Width=75
         Caption=iniLeng.readStr("Barras CentroSuperiores\CaptionObjetos")
         Transparent=True
       End Object
       Object cmbObjetos as ComboBox
         Left=85
         Top=4
         Width=200
         Sorted=True
         OnClick=cmbObjetos_Onclick
       End Object
       Object lblVariables as label
         Left=290
         Top=4
         Width=60
         Caption=iniLeng.readStr("Barras CentroSuperiores\CaptionVariables")
         Transparent=True
       End Object
       Object cmbVariables as ComboBox
         Left=355
         Top=4
         Width=200
         Sorted=True
         Onclick=cmbVariables_Onclick
       End Object
       Object lblFavoritos as label
         Left=560
         Top=4
         Width=75
         Caption=iniLeng.readStr("Barras CentroSuperiores\CaptionFavoritas")
         Transparent=True
       End Object
       Object cmbFavoritos as ComboBox
         Left=640
         Top=4
         Width=200
         Onclick=cmbFavoritos_Onclick
       End Object

     End object
     Object pnlCompilacion as Panel
       Align=albottom
       Height=75
       Object rchCompilacion as Richedit
         align=alClient
         Top=5
         Left=5
         Height=pnlCompilacion.height-10
         Width=pnlCompilacion.Width-10
         ReadOnly=True
         Scrollbars=ssVertical
         Color=val(iniConfig.readStr("Colores\Compilacion"))
         OnmouseMove=autoOcultar_OnMouseMove
       end Object
     End object
     Object tabEditor as tabControl
       Align=alClient
       addTab (iniLeng.readStr("TabEditor\Tab1"))
       AddTab(iniLeng.readStr("TabEditor\Tab2"))
       AddBMP(btmTabEditor)
       AddBMP(btmTabEditor)
       Onchange=tabeditor_OnChange
       '--------------------------------------------------------------------------->POPUP MENU
       object ppMenu as PopupMenu
         Object ppmDeshacer as Menuitem
           Tag=150
           Caption=iniLeng.ReadStr("Menu\Deshacer")
          'bmpResource(resource)
          Onclick=ppMenu_OnClick
         end object
         Object ppmCortar as Menuitem
           Tag=151
           Caption=iniLeng.ReadStr("Menu\Cortar")
           'bmpResource(Resource)
           Onclick=ppMenu_OnClick
         end object
         Object ppmCopiar as Menuitem
           Tag=152
           Caption=iniLeng.ReadStr("Menu\Copiar")
           'bmpResource(resource)
           Onclick=ppMenu_OnClick
         end object
         Object ppmPegar as Menuitem
           Tag=153
           Caption=iniLeng.ReadStr("Menu\Pegar")
           'bmpResource(resource)
           Onclick=ppMenu_OnClick
         end object
         Object ppmSeleccionarTodo as Menuitem
           Tag=154
           Caption=iniLeng.ReadStr("Menu\SeleccionarTodo")
           'bmpResource(resource)
           Onclick=ppMenu_OnClick
         end object
         Object ppmSeparador1 as Menuitem
           Caption="-"
         End Object
         Object ppmComentar as Menuitem
           Tag=155
           Caption=iniLeng.ReadStr("Menu\Comentar")
          'bmpResource(resource)
           Onclick=ppMenu_OnClick
         end object
         Object ppmQuitarLineasVacias as Menuitem
           Tag=156
           Caption=iniLeng.ReadStr("Menu\QuitarLineasVacias")
           'bmpResource(resource)
            Onclick=ppMenu_OnClick
         end object
         Object ppmBorrarLinea as Menuitem
           Tag=157
           Caption=iniLeng.ReadStr("Menu\BorrarLinea")
           'bmpResource(resource)
           Onclick=ppMenu_OnClick
         end object
         Object ppmlineasFavoritas as Menuitem
           Tag=158
           Caption=iniLeng.ReadStr("Menu\favoritas")
           'bmpResource(resource)
           Onclick=ppMenu_OnClick
         end object

       End object
'---------------------------------------------------------------------------FIN POPUP MENU
       Object rchNumeracion1 as richedit
         Align=alleft  
         alignment=taRight
         Width=80
         Visible=True
         font.name=fntEditor.name
         Font.size=fntEditor.size
         AddText("1")
         ReadOnly=True
         Color=val(iniConfig.readStr("Colores\Numeracion"))
         OnmouseMove=autoOcultar_OnMouseMove
         OnEnter=rchNumeracion_OnEnter

       End Object
       Object rchNumeracion2 as richedit
         Align=alleft 
         alignment=taRight 
         Width=80
         Visible=False
         font.name=fntEditor.name
         Font.size=fntEditor.size
         AddText("1")
         ReadOnly=True
         Color=val(iniConfig.readStr("Colores\Numeracion"))
         OnmouseMove=autoOcultar_OnMouseMove
         OnEnter=rchNumeracion_OnEnter

       End Object
       Object rchEditor1 as richedit
         Align=alClient
         'AddText(" ")
         PlainText=True
         WordWrap=False
         WantTabs=True
         Scrollbars=ssBoth
         OnkeyUp=rchEditores_Onkeyup
         OnkeyDown=rcheditores_onKeyDown
         OnKeyPress=rcheditores_onKeyPress
         OnMouseDown=rcheditores_onMouseDown
         Onchange=rcheditores_onChange
         Size=1024*1024*2
         font.name=fntEditor.name
         Font.size=fntEditor.size
       End Object
       Object rchEditor2 as richedit
         Align=alClient
         Visible=false
         PlainText=True
         WordWrap=False
         WantTabs=True
         Scrollbars=ssBoth
         'AddText(" ")
         OnkeyUp=rchEditores_Onkeyup
         OnkeyDown=rcheditores_onKeyDown
         OnKeyPress=rcheditores_onKeyPress
         OnMouseDown=rcheditores_onMouseDown
         OnChange=rcheditores_onChange
         Size=1024*1024*2
         font.name=fntEditor.name
         Font.size=fntEditor.size
       End Object
       Object rchTemporal as richedit
         Align=alClient
         Visible=false
         PlainText=True
         WordWrap=False
         WantTabs=True
         Scrollbars=ssBoth
         Size=1024*1024*2
         font.name=fntEditor.name
         Font.size=fntEditor.size
       End Object

     End Object
   End object
'--------------------------------------------------------------->FIN PANEL CENTRAL
'--------------------------------------------------------------->PANEL DERECHO
   Object pnlDerecho as Panel
     Align=alRight
     Bevelinner =2
     Width=56
     Object btnfaceActualizar as facebutton
       'Tag=201
       Left=15
       Top=10
       Width=26
       Height=26
       Flat=true
       Cursor=-21
       Hint=iniLeng.readStr("Barra Derecha\HintActualizar")
       ShowHint=True
       Bitmap.loadfromfile(exepath+"\Recursos\Actualizar.bmp")
       OnClick=BuscarObjetos_OnClick
     End Object
   End object
'---------------------------------------------------------------->FIN PANEL DERECHO
  'Fin otros objetos
  OnShow= frmPrincipal_Onshow
  Onclose=frmPrincipal_onClose

End Object
'---------------------------------------------------------------->FIN FRMPRINCIPAL
'---------------------------------------------------------------->FRMBUSCAR

Object frmBuscar as form
  Top=tabEditor.top+55
  Left=screenwidth-frmBuscar.clientWidth*1.67
  borderstyle=bsdialog
  Caption=iniLeng.readstr("FormBuscar\Captionform")
  parent=frmPrincipal
  Object lblBuscar as label
    top=5
    Left=5
    Transparent=true
    caption=iniLeng.readstr("FormBuscar\labelBuscar")
  End object
  Object lblReemplazar as label
    Top=lblBuscar.top+lblBuscar.height+20
    Left=5
    caption=iniLeng.readstr("FormBuscar\labelReemplazar")
  End object
  Object edtBuscar as Edit
    Top=5
    left=lblReemplazar.width+18
    'OnKeyPress=edtBuscar_onKeypress
  End Object
  Object edtReemplazar as Edit
    top=lblReemplazar.top
    left=lblReemplazar.width+18
  end object
  object grpDireccion as groupbox
    Left=(frmBuscar.width/2)-(grpDireccion.width/2)
    Top=edtReemplazar.top+edtReemplazar.Height+5
    Caption=iniLeng.readstr("FormBuscar\CaptionGrupo")
    Object rdoAdelante as radioButton
      left=5
      Top=15  
      Checked=true
      Caption=iniLeng.readstr("FormBuscar\CaptionRadio1")
    End object
    Object rdoAtras as RadioButton
      left=5
      Top=rdoAdelante.top+rdoAdelante.Height+5
      Caption=iniLeng.readstr("FormBuscar\CaptionRadio2")
    End Object
  End Object
  object btnBuscar as button
    top=grpDireccion.Top+grpDireccion.height+5
    Left=5
    Caption=iniLeng.readstr("FormBuscar\CaptionBuscar")
    onclick=btnBuscar_onclick  
  end object
  object btnReemplazar as button
    caption=iniLeng.readstr("FormBuscar\CaptionReemplazar")
    top=btnBuscar.Top
    left=btnBuscar.left+btnBuscar.width+5
    onclick=btnReemplazar_OnClick
  end object
 
  'clientwidth=nxt.width+nxt.left
  'clientheight=nxt.height+nxt.top
End object
'----------------------------------------------------------------FIN FRMBUSCAR

'---------------------------------------------------------------->EJECUTAR (LOAD AND SHOW)
frmPrincipal.WindowState=WsMaximized
frmPrincipal.Showmodal
'---------------------------------------------------------------->FIN EJECUTAR
'======================================================================================================
'{SUBS Y FUNCS. MDULO PRINCIPAL}
'======================================================================================================
Sub frmPrincipal_OnShow
  Dim CoordX as integer
  Dim titulo as string
  titulo=ucase$(iniLeng.ReadStr("Panel Izquierdo\Captiontitulo1"))
  coordX=imgTitulo.width-(imgTitulo.canvas.TextWidth(titulo)+5)
  imgTitulo.canvas.textout(coordX,10,titulo,clRojo)
  expandirLibre=False
  'Establecer mrgenes
   With SendMessageAPI
    hWnd=rchEditor1.hwnd
    wMsg=EM_SETMARGINS
    wParam=EC_LEFTMARGIN or EC_RIGHTMARGIN
    lParam=20+20*&H10000 
    execute
  End With
  With SendMessageAPI
    hWnd=rchEditor2.hwnd
    wMsg=EM_SETMARGINS
    wParam=EC_LEFTMARGIN or EC_RIGHTMARGIN
    lParam=20+20*&H10000
    execute
  End With 
rchEditor1.setfocus
End sub
'=====================================================================================================
Sub frmPrincipal_onClose
  call salir
end sub
'======================================================================================================
Sub autoOcultar_Onclick(Sender as Button)
  If expandirLibre=true then
    Sender.bitmap.loadFromFile(exepath+"\Recursos\Fijo.bmp")
    expandirLibre=false
  else
    Sender.bitmap.loadFromFile(exepath+"\Recursos\Libre.bmp")
    expandirLibre=True
  end if
End sub
'=====================================================================================================
Sub autoOcultar_OnMouseMove
  if expandirLibre=True then pnlIzquierdo.Width=88
End Sub
'======================================================================================================
Sub Menu_OnClick(Sender as menuItem)
  Select case Sender.tag
    Case 0
      '{nuevo}
      Call Nuevo
    Case 1
      '{Abrir archivo}
      Call abrirArchivo
    Case 2
      '{Recientes1}
    Case 3
      '{Recientes2}
    Case 4
      '{Recientes3}
    Case 5
      '{Recientes 4}
    Case 6
      '{Guardar}
      Call GuardarArchivo
    Case 7
      '{Guardar Como}
      Call GuardarComo
    Case 8
      '{Imprimir}
      Call Imprimir
    Case 9
      '{Salir}
      Call salir
    Case 10
      '{Deshacer/Reahacer}
      Call Deshacer
    Case 11
      '{Cortar}
      Call Cortar
    Case 12
      '{Copiar}
      Call Copiar
    Case 13
      '{Salir}
      Call Pegar
    Case 14
      '{Seleccionar todo}
      Call Seleccionartodo
    Case 15
      '{Comentar}
      Call comentar
    Case 16
      '{Quitar lineas en blanco}
      Call QuitarlineasVacias
    Case 17
      '{Borrar linea}
      Call borrarLinea
    case 18
       '{aadir a favoritos}
      Call agregarLineasfavoritas
    case 20
       '{Buscar}
      frmBuscar.show

    Case 22
      '{Compilar}
      Call Compilar
    Case 23
      '{CompilarEjecutar}
      Call CompilarEjecutar
    Case 24
      '{AyudaFNX}
      Call AyudaFNX

  End select 

End Sub
'======================================================================================================
Sub ppMenu_OnClick(Sender as menuitem)
  Select case Sender.tag
    Case 150
      '{Deshacer}
      Call Deshacer
    Case 151
      '{Cortar}
      Call Cortar
    Case 152
      '{Copiar}
      Call copiar
    Case 153
      '{Pegar}
      Call pegar
     Case 154
      '{SeleccionarTodo}
      Call Seleccionartodo
    Case 155
      '{Comentar/Descomentar}
      Call comentar
    Case 156
      '{Quitar lineas en blanco}
      Call quitarlineasVacias
    Case 157
      '{Borrar lnea}
      Call borrarLinea
    case 158
       '{aadir a favoritos}
      Call agregarLineasfavoritas
    End Select
  End Sub
'=====================================================================================================
Sub pnlSuperior_OnClick(Sender as faceButton)
  Select case Sender.tag
    Case 100
      '{nuevo}
      Call Nuevo
    Case 101
      '{Abrir archivo}
      Call abrirArchivo
    Case 102
      '{Guardar}
      Call GuardarArchivo
    Case 103
      '{Imprimir}
      Call imprimir
    Case 104
      '{Deshacer}
      Call Deshacer
    Case 105
      '{Cortar}
      Call Cortar
    Case 106
      '{Copiar}
      Call Copiar
    Case 107
      '{pegar}
      Call pegar
    Case 108
      '{Buscar/reemplazar}
      frmBuscar.show
    Case 109
      '{compilarEjecutar}
      Call compilarEjecutar
    Case 110
      '{AyudaFNX}
      Call ayudaFNX
  End select 

End Sub

'======================================================================================================
Sub panelIzquierdo_OnClick(Sender as facebutton)
  Dim CoordX as integer
  Dim titulo as string
  Select Case Sender.tag
    Case 200
      imgTitulo.Canvas.fill(1,10,clrojo,clGris)
      titulo=ucase$(iniLeng.ReadStr("Panel Izquierdo\Captiontitulo1"))
      coordX=imgTitulo.width-(imgTitulo.canvas.TextWidth(titulo)+5)
      imgTitulo.canvas.textout(coordX,10,titulo,clRojo)
      pnlIzquierdo.Width=380
      pnlHerramientas.visible=True
      grpNotas.visible=False
      grpCalculadora.visible=False
      grpColores.visible=False
      grpCodigos.visible=False
    Case 201
      imgTitulo.Canvas.fill(1,10,clrojo,clGris)
      titulo=ucase$(iniLeng.ReadStr("Panel Izquierdo\Captiontitulo2"))
      coordX=imgTitulo.width-(imgTitulo.canvas.TextWidth(titulo)+5)
      imgTitulo.canvas.textout(coordX,10,titulo,clRojo)
      pnlIzquierdo.Width=380
      pnlHerramientas.visible=False
      grpNotas.visible=True
      grpCalculadora.visible=False
      grpColores.visible=False
      grpCodigos.visible=False
    Case 202
      imgTitulo.Canvas.fill(1,1,clrojo,clGris)
      titulo=ucase$(iniLeng.ReadStr("Panel Izquierdo\Captiontitulo3"))
      coordX=imgTitulo.width-(imgTitulo.canvas.TextWidth(titulo)+5)
      imgTitulo.canvas.textout(coordX,10,titulo,clRojo)
      pnlIzquierdo.Width=380
      pnlHerramientas.visible=False
      grpNotas.visible=False
      grpCalculadora.visible=True
      grpColores.visible=False
      grpCodigos.visible=False
    Case 203
      imgTitulo.Canvas.fill(1,1,clrojo,clGris)
      titulo=ucase$(iniLeng.ReadStr("Panel Izquierdo\Captiontitulo4"))
      coordX=imgTitulo.width-(imgTitulo.canvas.TextWidth(titulo)+5)
      imgTitulo.canvas.textout(coordX,10,titulo,clRojo)
      pnlIzquierdo.Width=380
      pnlHerramientas.visible=False
      grpNotas.visible=False
      grpCalculadora.visible=False
      grpColores.visible=True
      grpCodigos.visible=False

    Case 204
      imgTitulo.Canvas.fill(1,1,clrojo,clGris)
      titulo=ucase$(iniLeng.ReadStr("Panel Izquierdo\Captiontitulo5"))
      coordX=imgTitulo.width-(imgTitulo.canvas.TextWidth(titulo)+5)
      imgTitulo.canvas.textout(coordX,10,titulo,clRojo)
      pnlIzquierdo.Width=380
      pnlHerramientas.visible=False
      grpNotas.visible=False
      grpCalculadora.visible=False
      grpColores.visible=False
      grpCodigos.visible=True
  End Select
End Sub
'=====================================================================================================
Sub btnSangria_OnClick(Sender as Button)
  Dim nivel as integer
  nivel=val(edtsangria.text)
  Select case Sender.Tag
    Case 250
      Inc(nivel)
      if nivel>=15 then nivel=15
      edtSangria.text=str$(nivel)
    Case 251
      Dec(nivel)
      if nivel<=0 then nivel=1
      edtSangria.text=str$(nivel)
    Case 252
      edtSangria.text=str$(1)
  End Select
End Sub
'======================================================================================================
Sub tabEditor_OnChange(Sender as TabControl)
  Select case Sender.TabIndex
    Case 0
      rchNumeracion2.Visible=False
      rchNumeracion1.Visible=True
      rchEditor2.Visible=False
      rcheditor1.Visible=True
      lstSubFun.clear
      staEstado.paneltext(0)=""
      Call BuscarObjetos_onClick
      if rutaArchivo(0)="" then 
        frmPrincipal.Caption="IdealEdit"
        staEstado.PanelText(1)=""
      else
        frmPrincipal.Caption="IdealEdit - "+NombreArchivo(0)
        staEstado.PanelText(1)=RutaArchivo(0)
      end if
      call cambiaFavoritos
      rchEditor1.setfocus
    Case 1
      rchNumeracion1.visible=False
      rchNumeracion2.Visible=True
      rcheditor1.Visible=False
      rchEditor2.Visible=True
      lstSubFun.clear
      staEstado.paneltext(0)=""
      Call BuscarObjetos_onClick
      if rutaArchivo(1)="" then 
        frmPrincipal.Caption="IdealEdit"
        staEstado.PanelText(1)=""
      else
        frmPrincipal.Caption="IdealEdit - "+NombreArchivo(1)
        staEstado.PanelText(1)=RutaArchivo(1)
      end if
      call cambiaFavoritos
      rchEditor2.setfocus
  End Select
End Sub
'======================================================================================================
Sub tabObjetos_OnChange(Sender as TabControl)
  Select case Sender.TabIndex
    Case 0
      pnlVisibles.Visible=True
      pnlNoVisibles.Visible=False
      PnlDialogos.Visible=False
    Case 1
      pnlVisibles.Visible=False
      pnlNoVisibles.Visible=True
      PnlDialogos.Visible=False
    Case 2
      pnlVisibles.Visible=False
      pnlNoVisibles.Visible=false
      PnlDialogos.Visible=True
  End Select
End Sub
'======================================================================================================
sub tmrSintaxis_Ontimer 
  if rchEditor1.SelLength=0 then ExaminaLinea
End sub
Sub ExaminaLinea
  Dim LongSeleccion as Long
  select case TabEditor.tabindex
    case 0
      LongSeleccion=rchEditor1.SelLength
      If LongSeleccion>0 then Exit Sub
      if rchEditor1.SelStart=posicionPrevia then Exit Sub
      posicion=rchEditor1.SelStart
      iniSeleccion=posicion
      posicionPrevia=posicion
      SendMessageAPI.hwnd=rchEditor1.hwnd
      SendMessageAPI.wMsg=EM_HIDESELECTION
      SendMessageAPI.wParam=1
      SendMessageAPI.lParam=0
      SendMessageAPI.execute
      numLinea=rchEditor1.row
      if numLinea<>0 then
        anteriorPrimerCaracter=RInstr(posicion,rchEditor1.Text,Chr$(13)+Chr$(10))+1
      else
        anteriorPrimerCaracter=RInstr(posicion,rchEditor1.Text,Chr$(13)+Chr$(10))
      end if
      rchEditor1.SelStart=anteriorPrimerCaracter
      rchEditor1.SelLength=0
      Call ColoreaLineas
      rchEditor1.SelStart=iniSeleccion
      rchEditor1.SelLength=LongSeleccion
      SendMessageAPI.hwnd=rchEditor1.hwnd
      SendMessageAPI.wMsg=EM_HIDESELECTION
      SendMessageAPI.wParam=0
      SendMessageAPI.lParam=0
      SendMessageAPI.execute
   case 1
      LongSeleccion=rcheditor2.SelLength
      If LongSeleccion>0 then Exit Sub
      if rcheditor2.SelStart=posicionPrevia then Exit Sub
      posicion=rcheditor2.SelStart
      iniSeleccion=posicion
      posicionPrevia=posicion
      SendMessageAPI.hwnd=rcheditor2.hwnd
      SendMessageAPI.wMsg=EM_HIDESELECTION
      SendMessageAPI.wParam=1
      SendMessageAPI.lParam=0
      SendMessageAPI.execute
      numLinea=rcheditor2.row
      if numLinea<>0 then
        anteriorPrimerCaracter=RInstr(posicion,rcheditor2.Text,Chr$(13)+Chr$(10))+1
      else
        anteriorPrimerCaracter=RInstr(posicion,rcheditor2.Text,Chr$(13)+Chr$(10))
      end if
      rcheditor2.SelStart=anteriorPrimerCaracter
      rcheditor2.SelLength=0
      Call ColoreaLineas
      rcheditor2.SelStart=iniSeleccion
      rcheditor2.SelLength=LongSeleccion
      SendMessageAPI.hwnd=rcheditor2.hwnd
      SendMessageAPI.wMsg=EM_HIDESELECTION
      SendMessageAPI.wParam=0
      SendMessageAPI.lParam=0
      SendMessageAPI.execute
  end select
End Sub
'===========================================================================
Sub coloreaFragmento
   dim texto as string,textoTemporal as string,caracter as string,operadores as string,numeros as string
  dim final as integer,i as integer,j as integer,finCadena as integer,inicio as integer,selComienzo as integer, AscCaracter as integer,x as integer
  Dim cadena as boolean, otros as boolean
  operadores="+-*/=()<>.,"
  numeros="0123456789"
  select case tabeditor.tabindex
    case 0
      otros=False
      Cadena=false
      inicio=0
      texto=""
      textotemporal=""
      for j=lineaInicial to lineafinal
        texto=rcheditor1.line(j)          '+crlf
        sendmessageAPI.hwnd=rchEditor1.hwnd
        sendmessageAPI.wMsg=EM_LINEINDEX
        sendmessageAPI.wParam=j
        sendmessageAPI.lparam=0
        sendmessageAPI.execute
        primercaracter=sendmessageAPI.result
        rchEditor1.SelStart=primerCaracter
        rchEditor1.SelLength=len(texto)
        fntEditor.color=clnegro
        rchEditor1.assignselfont=fntEditor
      final=len(texto)+1
      for i=1 to final-1
        Caracter=Char$(texto,i)
        ascCaracter=asc(Caracter)
        select case asccaracter
          case 34
            finCadena=Instr(i+1,texto,Chr$(34))
            if finCadena>0 then
              cadena=false
              rchEditor1.SelStart=primerCaracter+i-1
              rchEditor1.SelLength=finCadena-i+1
              fntEditor.color=clcadenas
              rchEditor1.assignselfont=fntEditor
              i=finCadena
              if textoTemporal="" then otros=True
            else
              if textoTemporal="" then
                cadena=true
                rchEditor1.SelStart=primerCaracter+i-1
                rchEditor1.SelLength=final-i
                fntEditor.color=clcadenas
                rchEditor1.assignselfont=fntEditor
              end if
            end if
         case 39
           if cadena=false  then
              rchEditor1.SelStart=primerCaracter+i-1
              rchEditor1.SelLength=final-i
              fntEditor.color=clcomentario
              rchEditor1.assignselfont=fntEditor
              i=final
              if textoTemporal="" then otros=True
            end if
          case else
            if cadena=false and InStr(1,operadores,caracter)>0 then
              rchEditor1.SelStart=primerCaracter+i-1
              rchEditor1.SelLength=1
              fntEditor.color=clOperadores
              rchEditor1.assignselfont=fntEditor
              if textoTemporal="" then otros=true
            End if
            if cadena=false and InStr(1,numeros,caracter)>0 then
              rchEditor1.SelStart=primerCaracter+i-1
              rchEditor1.SelLength=1
              fntEditor.color=clnumeros
              rchEditor1.assignselfont=fntEditor
              if textoTemporal="" then otros=True
            end if
            if otros=False then
              if (AscCaracter>=97 and AscCaracter<=122) or (AscCaracter>=65 and AscCaracter<=90) or ascCaracter=36 or ascCaracter=95 then 
                if textoTemporal="" then inicio=i
                textoTemporal=textoTemporal+caracter 
                if i<>final-1 then otros=True else otros=false
              end if 
            end if
            if otros=False and cadena=false then
              if Trim$(textoTemporal)<>"" then
                textoTemporal=UCase$(Trim$(textoTemporal) )
                if  hasReservadas1.SetAddress(textoTemporal)>=0 then
                  selComienzo=primerCaracter+inicio-1
                  if selComienzo<primerCaracter then selComienzo=primerCaracter
                  rchEditor1.SelStart=selComienzo
                  rchEditor1.SelLength=Len(textoTemporal)
                  fntEditor.color=clpalabras
                  rchEditor1.assignselfont=fntEditor
                  rchEditor1.seltext=ucase$(left$(textotemporal,1))+lcase$(right$(textotemporal,len(textotemporal)-1))
                end if
                if  hasReservadas2.SetAddress(textoTemporal)<>-1 then
                  selComienzo=primerCaracter+inicio-1
                  if selComienzo<primerCaracter then selComienzo=primerCaracter
                  rchEditor1.SelStart=selComienzo
                  rchEditor1.SelLength=Len(textoTemporal)
                  fntEditor.color=clPalabras2
                  rchEditor1.assignselfont=fntEditor
                  rchEditor1.seltext=ucase$(left$(textotemporal,1))+lcase$(right$(textotemporal,len(textotemporal)-1))
                end if
              end if
              textoTemporal=""
            end if
          end select
          otros=False
        next i
        next j
    case 1
      otros=False
      Cadena=false
      inicio=0
      texto=""
      textotemporal=""
      for j=lineaInicial to lineafinal
        texto=rchEditor2.line(j)          '+crlf
        sendmessageAPI.hwnd=rchEditor2.hwnd
        sendmessageAPI.wMsg=EM_LINEINDEX
        sendmessageAPI.wParam=j
        sendmessageAPI.lparam=0
        sendmessageAPI.execute
        primercaracter=sendmessageAPI.result
        rchEditor2.SelStart=primerCaracter
        rchEditor2.SelLength=len(texto)
        fntEditor.color=clnegro
        rchEditor2.assignselfont=fntEditor
      final=len(texto)+1
      for i=1 to final-1
        Caracter=Char$(texto,i)
        ascCaracter=asc(Caracter)
        select case asccaracter
          case 34
            finCadena=Instr(i+1,texto,Chr$(34))
            if finCadena>0 then
              cadena=false
              rchEditor2.SelStart=primerCaracter+i-1
              rchEditor2.SelLength=finCadena-i+1
              fntEditor.color=clcadenas
              rchEditor2.assignselfont=fntEditor
              i=finCadena
              if textoTemporal="" then otros=True
            else
              if textoTemporal="" then
                cadena=true
                rchEditor2.SelStart=primerCaracter+i-1
                rchEditor2.SelLength=final-i
                fntEditor.color=clcadenas
                rchEditor2.assignselfont=fntEditor
              end if
            end if
         case 39
           if cadena=false  then
              rchEditor2.SelStart=primerCaracter+i-1
              rchEditor2.SelLength=final-i
              fntEditor.color=clcomentario
              rchEditor2.assignselfont=fntEditor
              i=final
              if textoTemporal="" then otros=True
            end if
          case else
            if cadena=false and InStr(1,operadores,caracter)>0 then
              rchEditor2.SelStart=primerCaracter+i-1
              rchEditor2.SelLength=1
              fntEditor.color=clOperadores
              rchEditor2.assignselfont=fntEditor
              if textoTemporal="" then otros=true
            End if
            if cadena=false and InStr(1,numeros,caracter)>0 then
              rchEditor2.SelStart=primerCaracter+i-1
              rchEditor2.SelLength=1
              fntEditor.color=clnumeros
              rchEditor2.assignselfont=fntEditor
              if textoTemporal="" then otros=True
            end if
            if otros=False then
              if (AscCaracter>=97 and AscCaracter<=122) or (AscCaracter>=65 and AscCaracter<=90) or ascCaracter=36 or ascCaracter=95 then 
                if textoTemporal="" then inicio=i
                textoTemporal=textoTemporal+caracter 
                if i<>final-1 then otros=True else otros=false
              end if 
            end if
            if otros=False and cadena=false then
              if Trim$(textoTemporal)<>"" then
                textoTemporal=UCase$(Trim$(textoTemporal) )
                if  hasReservadas1.SetAddress(textoTemporal)>=0 then
                  selComienzo=primerCaracter+inicio-1
                  if selComienzo<primerCaracter then selComienzo=primerCaracter
                  rchEditor2.SelStart=selComienzo
                  rchEditor2.SelLength=Len(textoTemporal)
                  fntEditor.color=clpalabras
                  rchEditor2.assignselfont=fntEditor
                  rchEditor2.seltext=ucase$(left$(textotemporal,1))+lcase$(right$(textotemporal,len(textotemporal)-1))
                end if
                if  hasReservadas2.SetAddress(textoTemporal)<>-1 then
                  selComienzo=primerCaracter+inicio-1
                  if selComienzo<primerCaracter then selComienzo=primerCaracter
                  rchEditor2.SelStart=selComienzo
                  rchEditor2.SelLength=Len(textoTemporal)
                  fntEditor.color=clPalabras2
                  rchEditor2.assignselfont=fntEditor
                  rchEditor2.seltext=ucase$(left$(textotemporal,1))+lcase$(right$(textotemporal,len(textotemporal)-1))
                end if
              end if
              textoTemporal=""
            end if
          end select
          otros=False
        next i
        next j

    end select

End sub
'===========================================================================
Sub ColoreaLineas
  dim texto as string,textoTemporal as string,caracter as string,operadores as string,numeros as string
  dim final as integer,i as integer,j as integer,finCadena as integer,inicio as integer,selComienzo as integer, AscCaracter as integer
  Dim cadena as boolean, otros as boolean
  operadores="+-*/=()<>.,"
  numeros="0123456789"
  select case tabeditor.tabindex
    case 0
      posicion=rchEditor1.SelStart
      longitudLinea=Len(rchEditor1.Line(numLinea))
      primerCaracter=anteriorPrimerCaracter
      texto=rchEditor1.line(numLinea)
      textoTemporal=""
      final=longitudLinea+1
      i=1
      otros=False
      Cadena=false
      inicio=0
      rchEditor1.SelStart=primerCaracter
      rchEditor1.SelLength=longitudLinea
      fntEditor.color=clnegro
      rchEditor1.assignselfont=fntEditor
      for i=1 to final-1
        Caracter=Char$(texto,i)
        ascCaracter=asc(Caracter)
        select case asccaracter
          case 34
            finCadena=Instr(i+1,texto,Chr$(34))
            if finCadena>0 then
              cadena=false
              rchEditor1.SelStart=primerCaracter+i-1
              rchEditor1.SelLength=finCadena-i+1
              fntEditor.color=clcadenas
              rchEditor1.assignselfont=fntEditor
              i=finCadena
              if textoTemporal="" then otros=True
            else
              if textoTemporal="" then
                cadena=true
                rchEditor1.SelStart=primerCaracter+i-1
                rchEditor1.SelLength=final-i
                fntEditor.color=clcadenas
                rchEditor1.assignselfont=fntEditor
              end if
            end if
          case 39
            if cadena=false  then
              rchEditor1.SelStart=primerCaracter+i-1
              rchEditor1.SelLength=final-i
              fntEditor.color=clcomentario
              rchEditor1.assignselfont=fntEditor
              i=final
              if textoTemporal="" then otros=True
            end if
          case else
            if cadena=false and InStr(1,operadores,caracter)>0 then
              rchEditor1.SelStart=primerCaracter+i-1
              rchEditor1.SelLength=1
              fntEditor.color=clOperadores
              rchEditor1.assignselfont=fntEditor
              if textoTemporal="" then otros=true
            End if
            if cadena=false and InStr(1,numeros,caracter)>0 then
              rchEditor1.SelStart=primerCaracter+i-1
              rchEditor1.SelLength=1
              fntEditor.color=clnumeros
              rchEditor1.assignselfont=fntEditor
              if textoTemporal="" then otros=True
            end if
            if otros=False then
              if (AscCaracter>=97 and AscCaracter<=122) or (AscCaracter>=65 and AscCaracter<=90) or ascCaracter=36 or ascCaracter=95 then 
                if textoTemporal="" then inicio=i
                textoTemporal=textoTemporal+caracter 
                if i<>final-1 then otros=True else otros=false
              end if 
            end if
            if otros=False and cadena=false then
              if Trim$(textoTemporal)<>"" then
                textoTemporal=UCase$(Trim$(textoTemporal) )
                if  hasReservadas1.SetAddress(textoTemporal)>=0 then
                  selComienzo=primerCaracter+inicio-1
                  if selComienzo<primerCaracter then selComienzo=primerCaracter
                  rchEditor1.SelStart=selComienzo
                  rchEditor1.SelLength=Len(textoTemporal)
                  fntEditor.color=clpalabras
                  rchEditor1.assignselfont=fntEditor
                  rchEditor1.seltext=ucase$(left$(textotemporal,1))+lcase$(right$(textotemporal,len(textotemporal)-1))
                end if
                if  hasReservadas2.SetAddress(textoTemporal)<>-1 then
                  selComienzo=primerCaracter+inicio-1
                  if selComienzo<primerCaracter then selComienzo=primerCaracter
                  rchEditor1.SelStart=selComienzo
                  rchEditor1.SelLength=Len(textoTemporal)
                  fntEditor.color=clPalabras2
                  rchEditor1.assignselfont=fntEditor
                  rchEditor1.seltext=ucase$(left$(textotemporal,1))+lcase$(right$(textotemporal,len(textotemporal)-1))
                end if
              end if
              textoTemporal=""
            end if
          end select
          otros=False
        next i
    case 1
       posicion=rchEditor2.SelStart
       longitudLinea=Len(rchEditor2.Line(numLinea))
       primerCaracter=anteriorPrimerCaracter
       texto=rchEditor2.line(numLinea)
       textoTemporal=""
       final=longitudLinea+1
       i=1
       otros=False
       Cadena=false
       inicio=0
       
       rchEditor2.SelStart=primerCaracter
       rchEditor2.SelLength=longitudLinea
       fntEditor.color=clnegro
       rchEditor2.assignselfont=fntEditor
       for i=1 to final-1
         Caracter=Char$(texto,i)
         ascCaracter=asc(Caracter)
         select case asccaracter
           case 34
             finCadena=Instr(i+1,texto,Chr$(34))
             if finCadena>0 then
               cadena=false
               rchEditor2.SelStart=primerCaracter+i-1
               rchEditor2.SelLength=finCadena-i+1
               fntEditor.color=clcadenas
               rchEditor2.assignselfont=fntEditor
               i=finCadena
               if textoTemporal="" then otros=True
             else
               if textoTemporal="" then
                 cadena=true
                 rchEditor2.SelStart=primerCaracter+i-1
                 rchEditor2.SelLength=final-i
                 fntEditor.color=clcadenas
                 rchEditor2.assignselfont=fntEditor
               end if
             end if
           case 39
             if cadena=false  then
               rchEditor2.SelStart=primerCaracter+i-1
               rchEditor2.SelLength=final-i
               fntEditor.color=clcomentario
               rchEditor2.assignselfont=fntEditor
               i=final
               if textoTemporal="" then otros=True
             end if
           case else
             if cadena=false and InStr(1,operadores,caracter)>0 then
               rchEditor2.SelStart=primerCaracter+i-1
               rchEditor2.SelLength=1
               fntEditor.color=clOperadores
               rchEditor2.assignselfont=fntEditor
               if textoTemporal="" then otros=true
             End if
             if cadena=false and InStr(1,numeros,caracter)>0 then
               rchEditor2.SelStart=primerCaracter+i-1
               rchEditor2.SelLength=1
               fntEditor.color=clnumeros
               rchEditor2.assignselfont=fntEditor
               if textoTemporal="" then otros=True
             end if
             if otros=False then
               if (AscCaracter>=97 and AscCaracter<=122) or (AscCaracter>=65 and AscCaracter<=90) or ascCaracter=36 or ascCaracter=95 then 
                 if textoTemporal="" then inicio=i
                 textoTemporal=textoTemporal+caracter 
                 if i<>final-1 then otros=True else otros=false
               end if 
             end if
             if otros=False and cadena=false then
               if Trim$(textoTemporal)<>"" then
                 textoTemporal=UCase$(Trim$(textoTemporal) )
                 if  hasReservadas1.SetAddress(textoTemporal)>=0 then
                   selComienzo=primerCaracter+inicio-1
                   if selComienzo<primerCaracter then selComienzo=primerCaracter
                   rchEditor2.SelStart=selComienzo
                   rchEditor2.SelLength=Len(textoTemporal)
                   fntEditor.color=clpalabras
                   rchEditor2.assignselfont=fntEditor
                   rchEditor2.seltext=ucase$(left$(textotemporal,1))+lcase$(right$(textotemporal,len(textotemporal)-1))
                 end if
                 if  hasReservadas2.SetAddress(textoTemporal)<>-1 then
                   selComienzo=primerCaracter+inicio-1
                   if selComienzo<primerCaracter then selComienzo=primerCaracter
                   rchEditor2.SelStart=selComienzo
                   rchEditor2.SelLength=Len(textoTemporal)
                   fntEditor.color=clPalabras2
                   rchEditor2.assignselfont=fntEditor
                   rchEditor2.seltext=ucase$(left$(textotemporal,1))+lcase$(right$(textotemporal,len(textotemporal)-1))
                 end if
               end if
               textoTemporal=""
             end if
           end select
           otros=False
         next i
    end select
end Sub
'=========================================================================================================
Sub ColoreaArchivo
  dim textortf as string,textoTemporal as string,caracter as string,codigortf as string,textoTotal as string,primeralinea as string,operadores as string,numeros as string
  dim final as integer,AscCaracter as integer,finalComentario as integer,i as integer,x as integer,porcentaje as integer
  i=1
  porcentaje=0
  operadores="+-*/=()<>.,"
  numeros="0123456789"
  textoTotal=""
  primeraLinea=""
  codigortf="{\rtf1\ansi\ansicpg1252\deff0\nouicompat\deflang1033"+crlf+"{\colortbl;\red0\green0\blue255;\red0\green0\blue0;\red0\green128\blue12;\red255\green0\blue255;\red0\green165\blue255;\red161\green78\blue26;\red255\green0\blue0;}"+crlf+"}"
  Select case tabeditor.TabIndex
    Case 0
      rcheditor1.Plaintext=false
      textortf=rcheditor1.rtftext
    case 1
      rcheditor2.Plaintext=false
      textortf=rcheditor2.rtftext
   end select
   for x=1 to len(textortf)
     primeraLinea=primeraLinea+char$(textortf,x)
     if char$(textortf,x)=chr$(13) then exit for
   next x
   textortf=replacesubstr$(textortf,primeralinea,"")
   textortf=primeraLinea+codigortf+textortf
   final=len(textortf)
   frmEspera.show
   pgrEspera.max=final
   lblEspera.Caption=iniLeng.readstr("formEspera\captionEtiqueta")
   lblEspera.repaint
   While i<final
     pgrEspera.Position=i
'    porcentaje=int((i*100)/final)
'    lblEspera.caption="Syntax coloring"+string$("-",porcentaje)+">"    '+str$(Porcentaje)+Space$(1)+"%"
     Caracter=char$(textortf,i)
     ascCaracter=asc(caracter)
     inc(i)
     if  (AscCaracter>=97 and AscCaracter<=122) or (AscCaracter>=65 and AscCaracter<=90) or ascCaracter=36 or ascCaracter=95  then
       TextoTemporal=textotemporal+Caracter
     else
       select case ascCaracter
         case 34
           'Colorea cadenas
            Textotemporal=""
            do 
              Textotemporal=Textotemporal+caracter        
              caracter=char$(textortf,i)
              inc(i)
            loop until caracter=chr$(13) or caracter=chr$(34)
            Textotemporal="\cf3 "+Textotemporal+chr$(34)+"\cf2 " 
          case 39 
            'Colorea comentarios
             textotemporal=""
             finalComentario=instr(i+1,textoRtf,chr$(13))
             if finalComentario>0 then
               while i<=finalComentario
                 Textotemporal=textoTemporal+caracter        
                 caracter=char$(textortf,i)
                 inc(i)
               wend
               textotemporal="\cf7 "+textotemporal+"\cf2 "
             end if
           case else
             'Colorea operadores anteriores a nmeros
             if InStr(1,operadores,caracter)>0 then caracter="\cf4 "+caracter +"\cf2 "
            'colorea nmeros
            if char$(textortf,i-2)=space$(1) or instr(1-2,operadores,char$(textortf,i-2))>0 then
              while InStr(1,numeros,caracter)>0
                textotemporal=textotemporal+caracter        
                caracter=char$(textortf,i)
                inc(i)
              wend
              textotemporal="\cf6 "+textotemporal+"\cf2 "
            end if
            'colorea operadores posteriores a nmeros
            if InStr(1,operadores,caracter)>0 then caracter="\cf4 "+caracter +"\cf2 "
            'colorea reservadas1
            if hasReservadas1.setaddress(ucase$(Textotemporal))>0 then
              Textotemporal="\cf1 "+ucase$(left$(textotemporal,1))+lcase$(right$(textotemporal,len(textotemporal)-1))+"\cf2 "
            end if
           'Colorea reservadas2
           if hasReservadas2.setaddress(ucase$(Textotemporal))>0 then
             Textotemporal="\cf5 "+ucase$(left$(textotemporal,1))+lcase$(right$(textotemporal,len(textotemporal)-1))+"\cf2 "
           end if
           Textotemporal=textotemporal+caracter
           textoTotal=textoTotal+textotemporal
           textoTemporal=""
        end select
      end if
    Wend  
  if tabEditor.tabindex=0 then rchEditor1.rtftext=textoTotal+"}" else rchEditor2.rtftext=textoTotal+"}"
  frmEspera.closeForm
end Sub

'=======================================================================================================
Sub rchNumeracion_OnEnter
  if tabEditor.tabIndex=0 then rchEditor1.setFocus else rchEditor2.setFocus
End sub

'======================================================================================================
Sub rcheditores_onKeyup
  select case tabeditor.tabIndex
    case 0
      if rchEditor1.SelLength>0 then exit sub
      fntEditor.color=clNegro
      rchEditor1.assignselfont=fntEditor
    case 1
      if rchEditor2.SelLength>0 then exit sub
      fntEditor.color=clNegro
      rchEditor2.assignselfont=fntEditor
   End select
End sub
'======================================================================================================
Sub rcheditores_onKeyPress(Key as byte)
'Establecer espacios de tabulacion
 Dim longTab as integer
 LongTab=val(iniConfig.readStr("Tabulador\Espacios"))
  If tabEditor.tabIndex=0 then
    if key=9 then
      key=0
      rchEditor1.seltext=space$(longTab)
    end if
  else
    if key=9 then
      key=0
      rchEditor2.seltext=space$(LongTab)
    end if
  End if
End Sub
'=====================================================================================================
Sub rcheditores_onKeyDown
  If tabeditor.tabIndex=0 then
    staEstado.paneltext(0)="Ln:"+Space$(1)+str$((rcheditor1.row)+1)+space$(1)+"Col:"+space$(1)+str$(rchEditor1.col+1)
  else
    staEstado.paneltext(0)= "Ln:"+Space$(1)+str$(rcheditor2.row+1)+space$(1)+"Col:"+space$(1)+str$(rchEditor2.col+1)
  End if
End sub
'============================================================================================================
Sub rcheditores_onChange
  If tabeditor.tabIndex=0 then rchModificado1=True else rchModificado2=True
  call numerarLineas
End Sub
'=============================================================================================================
Sub rcheditores_onMouseDown
  If tabeditor.tabIndex=0 then
    staEstado.paneltext(0)="Ln:"+Space$(1)+str$((rcheditor1.row)+1)+space$(1)+"Col:"+space$(1)+str$(rchEditor1.col+1)
  else
     staEstado.paneltext(0)= "Ln:"+Space$(1)+str$(rcheditor2.row+1)+space$(1)+"Col:"+space$(1)+str$(rchEditor2.col+1)
  End if
End sub
'===========================================================================================================
Sub Compilar
  Dim rutaCompilador as string, LineaError as string, procID as long,Compilacion as string
  RutaCompilador=delete$(appAplicacion.ExeName,rinstr(appAplicacion.exename,"\")+1,len(right$(appAplicacion.exename,rinstr(appAplicacion.exename,"\"))))
  Compilacion=rutaCompilador+"FNXCompiler.exe"
  Select case tabEditor.TabIndex
    Case 0
      if len(rcheditor1.text)=0 then exit sub 'nada que compilar
      if rutaArchivo(0)="" then 
        call guardarComo
      else 
        call guardarArchivo
      end if
      if rchModificado1=false then      
        procID=run(Compilacion,rutaArchivo(0),SW_SHOW)
        if procID<0 then
          showmessage iniLeng.readStr("Mensajes Compilador\inicio")
          exit sub
        else
          fleStream.open(rutacompilador+"fnx.log")
          rchCompilacion.text="Compile Log: "+crlf+fleStream.readline+crlf+fleStream.readline+crlf+fleStream.readline+crlf
          rchCompilacion.text=rchCompilacion.Text+fleStream.readline
          fleStream.close
          if left$(ucase$(ltrim$(rchCompilacion.line(2))),5)="ERROR" then
            lineaError=field$(rchCompilacion.line(2)," ",4)
            call irlinea(lineaerror)
            'showmessage lineaerror
          End if 
        end if
      else
       exit sub   'abortar si no se ha guardado el archivo
      end if
    case 1
      if len(rcheditor2.text)=0 then exit sub 'Nada que compilar
      if rutaArchivo(1)="" then 
        call guardarComo
      else 
        call guardarArchivo
      end if
      if rchModificado2=false then 
        procID=run(Compilacion,rutaArchivo(1),SW_SHOW)
        if procID<0 then
          showmessage iniLeng.readStr("Mensajes Compilador\inicio")
          exit sub
        else
          fleStream.open(rutacompilador+"fnx.log")
          rchCompilacion.text="Compile Log: "+crlf+fleStream.readline+crlf+fleStream.readline+crlf+fleStream.readline+crlf
          rchCompilacion.text=rchCompilacion.Text+fleStream.readline
          fleStream.close
          if left$(ucase$(ltrim$(rchCompilacion.line(2))),5)="ERROR" then
            lineaError=field$(rchCompilacion.line(2)," ",4)
            call irlinea(lineaerror)
            'showmessage lineaerror
          End if 
         end if
       else
         exit sub  'abortar si no se ha guardado el archivo
       end if
   end select
End Sub
'============================================================================================================
Sub CompilarEjecutar
  Dim rutaCompilador as string, LineaError as string, procID as long,Compilacion as string,archivoExe as string,ejecutar as long, ejecutar2 as long
   RutaCompilador=delete$(appAplicacion.ExeName,rinstr(appAplicacion.exename,"\")+1,len(right$(appAplicacion.exename,rinstr(appAplicacion.exename,"\"))))
  Compilacion=rutaCompilador+"FNXCompiler.exe"
  Select case tabeditor.tabIndex
    case 0
      if len(rcheditor1.text)=0 then exit sub 'Nada que compilar
      if rutaarchivo(0)="" then 
         call guardarComo
        'if rchModificado1=True then exit sub 'no se ha guardado el archivo
      else 
        call guardarArchivo
      end if
      if ejecutar>0 then
        WaitforSingleObjectApi.hHandle=ejecutar
        WaitforSingleObjectApi.execute
        if WaitforSingleObjectApi.result>0 then
          ShowMessage iniLeng.readStr("Mensajes Compilador\UnaInstancia")
          exit sub
        end if
      end if
      if rchModificado1=False then
        procID=run(Compilacion,rutaArchivo(0),SW_SHOW)
        if procID<0 then
          showmessage iniLeng.readStr("Mensajes Compilador\inicio")
          exit sub
        else
          fleStream.open(rutacompilador+"fnx.log")
          rchCompilacion.text="Compile Log: "+crlf+fleStream.readline+crlf+fleStream.readline+crlf+fleStream.readline+crlf
          rchCompilacion.text=rchCompilacion.Text+fleStream.readline
          fleStream.close
          if left$(ucase$(ltrim$(rchCompilacion.line(2))),5)="ERROR" then
            lineaError=field$(rchCompilacion.line(2)," ",4)
            call irlinea(lineaerror)
          else
            archivoExe=replace$(rutaArchivo(0),".exe",len(rutaArchivo(0))-3) 
            ejecutar=shell(archivoExe,SW_SHOW )
          End if 
        end if
      Else
        exit sub  'abortar si se ha cancelado guardar archivo
      end if
    Case 1
      if len(rcheditor2.text)=0 then exit sub 'Nada que compilar
      if rutaArchivo(1)=""  then 
        call guardarComo
      else 
        call guardarArchivo
      end if
      if ejecutar>0 then
        WaitforSingleObjectApi.hHandle=ejecutar
        WaitforSingleObjectApi.execute
        if WaitforSingleObjectApi.result>0 then
          ShowMessage iniLeng.readStr("Mensajes Compilador\UnaInstancia")
          exit sub
        end if
      end if 
    if rchModificado2=false then 
      procID=run(Compilacion,rutaArchivo(1),SW_SHOW)
      if procID<0 then
        showmessage iniLeng.readStr("Mensajes Compilador\inicio")
        exit sub
      else
        fleStream.open(rutacompilador+"fnx.log")
        rchCompilacion.text="Compile Log: "+crlf+fleStream.readline+crlf+fleStream.readline+crlf+fleStream.readline+crlf
        rchCompilacion.text=rchCompilacion.Text+fleStream.readline
        fleStream.close
        if left$(ucase$(ltrim$(rchCompilacion.line(2))),5)="ERROR" then
          lineaError=field$(rchCompilacion.line(2)," ",4)
          call irlinea(lineaerror)
        else
          archivoExe=replace$(rutaArchivo(1),".exe",len(rutaArchivo(1))-3)
          ejecutar=shell(archivoExe,SW_SHOW )
        End if 
      end if
    Else
      exit sub   'abortar si se ha cancelado guardar archivo
    End if 
  End select
End Sub

'============================================================================================================
Sub Nuevo
  Dim resultado as integer
  If tabEditor.TabIndex=0 then
    if rutaArchivo(0)="" and len(rchEditor1.text)>0 then
       resultado=messageDlg(iniLeng.ReadStr("Mensajes Archivos\Nuevo"),iniLeng.ReadStr("Mensajes Archivos\CaptionGuardar"),mbyesno+mbiconquestion)
       if resultado=6 then Call GuardarComo
       rchEditor1.Clear
       NombreArchivo(0)=""
       TabEditor.tabs(tabEditor.tabindex)=iniLeng.readStr("TabEditor\Tab1")
       frmPrincipal.Caption="IdealEdit"
       RutaArchivo(0)=""
       staEstado.panelText(1)=""
       lstSubFun.clear
       cmbObjetos.clear
       cmbVariables.clear
       rchModificado1=False
       rchNumeracion1.clear
       rchnumeracion1.addtext("1")
       exit sub
    end if
    if rutaArchivo(0)<>"" and rchModificado1=True then
       resultado=messageDlg(iniLeng.ReadStr("Mensajes Archivos\Cambios"),iniLeng.ReadStr("Mensajes Archivos\CaptionGuardar"),mbyesno+mbiconquestion)
       if resultado=6 then Call GuardarArchivo
       rchEditor1.Clear
       NombreArchivo(0)=""
       TabEditor.tabs(tabEditor.tabindex)=iniLeng.readStr("TabEditor\Tab1")
       frmPrincipal.Caption="IdealEdit"
       RutaArchivo(0)=""
       staEstado.panelText(1)=""
       lstSubFun.clear
       cmbObjetos.clear
       cmbVariables.clear
       rchModificado1=False
       rchNumeracion1.clear
       rchnumeracion1.addtext("1")
       exit sub
    end if
    if rutaArchivo(0)<>"" then
      rchEditor1.Clear
       NombreArchivo(0)=""
       TabEditor.tabs(tabEditor.tabindex)=iniLeng.readStr("TabEditor\Tab1")
       frmPrincipal.Caption="IdealEdit"
       RutaArchivo(0)=""
       staEstado.panelText(1)=""
       lstSubFun.clear
       cmbObjetos.clear
       cmbVariables.clear
       rchModificado1=False
       rchNumeracion1.clear
       rchnumeracion1.addtext("1")
       exit sub
    end if

  else
    if rutaArchivo(1)="" and len(rchEditor2.text)>0 then
      resultado=messageDlg(iniLeng.ReadStr("Mensajes Archivos\Nuevo"),iniLeng.ReadStr("Mensajes Archivos\CaptionGuardar"),mbyesno+mbiconquestion)
      if resultado=6 then Call GuardarComo
      rchEditor2.Clear
      NombreArchivo(1)=""
      TabEditor.tabs(tabEditor.tabindex)=iniLeng.readStr("TabEditor\Tab2")
      frmPrincipal.Caption="IdealEdit"
      RutaArchivo(1)=""
      staEstado.panelText(1)=""
      lstSubFun.clear
      cmbObjetos.clear
      cmbVariables.clear
      rchModificado2=False
      rchNumeracion2.clear
      rchnumeracion2.addtext("1")
      exit sub
     end if
     if rutaArchivo(1)<>"" and rchModificado2=True then
       resultado=messageDlg(iniLeng.ReadStr("Mensajes Archivos\Cambios"),iniLeng.ReadStr("Mensajes Archivos\CaptionGuardar"),mbyesno+mbiconquestion)
       if resultado=6 then Call GuardarArchivo
       rchEditor2.Clear
       NombreArchivo(1)=""
       TabEditor.tabs(tabEditor.tabindex)=iniLeng.readStr("TabEditor\Tab2")
       frmPrincipal.Caption="IdealEdit"
       RutaArchivo(1)=""
       staEstado.panelText(1)=""
       lstSubFun.clear
       cmbObjetos.clear
       cmbVariables.clear
       rchModificado2=False
       rchNumeracion2.clear
       rchnumeracion2.addtext("1")
       exit sub
     end if
     if rutaArchivo(1)<>"" then
       rchEditor2.Clear
       NombreArchivo(1)=""
       TabEditor.tabs(tabEditor.tabindex)=iniLeng.readStr("TabEditor\Tab2")
       frmPrincipal.Caption="IdealEdit"
       RutaArchivo(1)=""
       staEstado.panelText(1)=""
       lstSubFun.clear
       cmbObjetos.clear
       cmbVariables.clear
       rchModificado2=False
       rchNumeracion2.clear
       rchnumeracion1.addtext("1")
       exit sub
     end if

  End If
End Sub
'=============================================================================================================
Sub abrirArchivo
  Dim barras as integer,numeros as integer,cargado as boolean
  fledialogo.caption=iniLeng.ReadStr("Mensajes Archivos\CaptionAbrir")
  fledialogo.buttontext=iniLeng.ReadStr("Mensajes Archivos\CaptionBotonAbrir")
  fledialogo.filter="FNX .bas|*.bas|libreras .lib|*.lib|Texto .txt|*.txt|include .inc|*.inc|All files|*.*" 
  fledialogo.initialdir=dir$("@")
  fledialogo.show 
  If tabEditor.TabIndex=0 then
     rchEditor1.cursor=crhourglass
    if fledialogo.filename<>"" then
      call nuevo
      fleStream.open(fleDialogo.filename)
      rcheditor1.text=fleStream.read(fleStream.size)
      cargado=true
      fleStream.close
      barras=tally(fleDialogo.filename,"\")
      NombreArchivo(0)=field$(fleDialogo.filename,"\",barras+1)
      TabEditor.tabs(tabEditor.tabindex)=nombreArchivo(0)
      frmPrincipal.Caption="IdealEdit - "+ nombreArchivo(0)
      RutaArchivo(0)=fleDialogo.filename
      staEstado.panelText(1)=rutaArchivo(0)
      fledialogo.filename=""
      rcheditor1.lock
      rchNumeracion1.clear
      while rchNumeracion1.linecount<=rcheditor1.linecount
        rchNumeracion1.Addtext(str$(rchNumeracion1.LineCount+1))
      wend
      call coloreaarchivo
      rchModificado1=False
    end if
    if cargado=true then
     
    call BuscarObjetos_OnClick
    cargado=false
    end if
     rchEditor1.unlock
     rchEditor1.cursor=crDefault
  Else
     rcheditor2.cursor=crhourglass
    if fledialogo.filename<>"" then
      call nuevo
      fleStream.open(fleDialogo.filename)
      rcheditor2.text=fleStream.read(fleStream.size)
      cargado=true
      fleStream.close
      barras=tally(fleDialogo.filename,"\")
      NombreArchivo(1)=field$(fleDialogo.filename,"\",barras+1)
      TabEditor.tabs(tabEditor.tabindex)=nombreArchivo(1)
      frmPrincipal.Caption="IdealEdit - "+ nombreArchivo(1)
      RutaArchivo(1)=fleDialogo.filename
      staEstado.panelText(1)=rutaArchivo(1)
      fledialogo.filename=""
      rcheditor2.lock
      rchNumeracion2.clear
      while rchNumeracion2.linecount<=rcheditor2.linecount
        rchNumeracion2.Addtext(str$(rchNumeracion2.LineCount+1))
      wend
      call coloreaarchivo
      rchModificado2=False
    end if
    if cargado=true then
    call BuscarObjetos_OnClick
    cargado=false
    end if
     rcheditor2.unlock
      rcheditor2.cursor=crDefault
  end if
End sub
'============================================================================================================
Sub GuardarArchivo
  If tabEditor.TabIndex=0 then
    if rutaArchivo(0)="" then
      call GuardarComo
    else
      kill rutaArchivo(0)
      fleStream.open(rutaArchivo(0))
      fleStream.write(rchEditor1.text)
      fleStream.size=fleStream.Position
      fleStream.close
      rchModificado1=false
    End If
  Else
    if rutaArchivo(1)="" then
      call GuardarComo
    else
      kill rutaArchivo(1)
      fleStream.open(rutaArchivo(1))
      fleStream.write(rchEditor2.text)
      fleStream.size=fleStream.Position
      fleStream.close
      rchModificado2=false
    End If
  End if
End Sub 
'============================================================================================================
Sub GuardarComo
  Dim barras as integer,extension as string,extensionExiste as integer,Resultado as integer
  fledialogo.caption=iniLeng.ReadStr("Mensajes Archivos\CaptionGuardar")
  fledialogo.buttontext=iniLeng.ReadStr("Mensajes Archivos\CaptionBotonGuardar")
  fledialogo.filter="FNX .bas|*.bas|libreras .lib|*.lib|Texto .txt|*.txt|include .inc|*.inc|All files|*.*" 
  fledialogo.initialdir=dir$("@")
  fledialogo.show 
  If tabEditor.TabIndex=0 then
    if fledialogo.filename<>"" then
      Select Case fleDialogo.filterIndex
         Case 1
           extension=".bas"
         Case 2
           extension=".lib"
         Case 3
           extension=".txt"
         Case 4
           extension=".inc"
         Case Else
           extension=""
      End Select
      extensionExiste=rinstr(fleDialogo.filename,".")
      if extensionExiste <> 0 then fleDialogo.filename=left$(fleDialogo.filename,extensionExiste-1)+extension else fledialogo.filename=fleDialogo.filename+extension
      if Fileexists(fledialogo.filename)=true then
        resultado=messageDlg(iniLeng.ReadStr("Mensajes Archivos\SobreEscribir"),iniLeng.ReadStr("Mensajes Archivos\CaptionGuardar"),mbyesno+mbiconquestion)
        if resultado=6 then
          fleStream.open(fleDialogo.filename)
          fleStream.write(rcheditor1.text)
          fleStream.close
          extension=right$(fleDialogo.filename,4)
          barras=tally(fleDialogo.filename,"\")
          NombreArchivo(0)=field$(fleDialogo.filename,"\",barras+1)
          TabEditor.tabs(tabEditor.tabindex)=nombreArchivo(0)
          frmPrincipal.Caption="IdealEdit - "+ nombreArchivo(0)
          RutaArchivo(0)=fleDialogo.filename
          staEstado.panelText(1)=rutaArchivo(0)
         'call BuscarObjetos_OnClick
          rchModificado1=False
          fleDialogo.filename=""
          exit sub
        else
          exit sub
        end if
      end if
      fleStream.open(fleDialogo.filename)
      fleStream.write(rcheditor1.text)
      fleStream.close
      extension=right$(fleDialogo.filename,4)
      barras=tally(fleDialogo.filename,"\")
      NombreArchivo(0)=field$(fleDialogo.filename,"\",barras+1)
      TabEditor.tabs(tabEditor.tabindex)=nombreArchivo(0)
      frmPrincipal.Caption="IdealEdit - "+ nombreArchivo(0)
      RutaArchivo(0)=fleDialogo.filename
      staEstado.panelText(1)=rutaArchivo(0)
      'call BuscarObjetos_OnClick
      rchModificado1=False
      fleDialogo.filename=""
    End if
  Else
   if fledialogo.filename<>"" then
      Select Case fleDialogo.filterIndex
         Case 1
           extension=".bas"
         Case 2
           extension=".lib"
         Case 3
           extension=".txt"
         Case 4
           extension=".inc"
         Case Else
           extension=""
      End Select
      extensionExiste=rinstr(fleDialogo.filename,".")
      if extensionExiste <> 0 then fleDialogo.filename=left$(fleDialogo.filename,extensionExiste-1)+extension else fledialogo.filename=fleDialogo.filename+extension
      if Fileexists(fledialogo.filename)=true then
        resultado=messageDlg(iniLeng.ReadStr("Mensajes Archivos\SobreEscribir"),iniLeng.ReadStr("Mensajes Archivos\CaptionGuardar"),mbyesno+mbiconquestion)
        if resultado=6 then
          fleStream.open(fleDialogo.filename)
          fleStream.write(rcheditor2.text)
          fleStream.close
          extension=right$(fleDialogo.filename,4)
          barras=tally(fleDialogo.filename,"\")
          NombreArchivo(1)=field$(fleDialogo.filename,"\",barras+1)
          TabEditor.tabs(tabEditor.tabindex)=nombreArchivo(1)
          frmPrincipal.Caption="IdealEdit - "+ nombreArchivo(1)
          RutaArchivo(1)=fleDialogo.filename
          staEstado.panelText(1)=rutaArchivo(1)
         'call BuscarObjetos_OnClick
          rchModificado2=False
          fleDialogo.filename=""

          exit sub
        else
          exit sub
        end if
      end if
      fleStream.open(fleDialogo.filename)
      fleStream.write(rcheditor2.text)
      fleStream.close
      extension=right$(fleDialogo.filename,4)
      barras=tally(fleDialogo.filename,"\")
      NombreArchivo(1)=field$(fleDialogo.filename,"\",barras+1)
      TabEditor.tabs(tabEditor.tabindex)=nombreArchivo(1)
      frmPrincipal.Caption="IdealEdit - "+ nombreArchivo(1)
      RutaArchivo(1)=fleDialogo.filename
      staEstado.panelText(1)=rutaArchivo(1)
      'call BuscarObjetos_OnClick
      rchModificado2=False
fleDialogo.filename=""

    End if

  End If

End Sub
'============================================================================================================
Sub Imprimir
  If tabEditor.tabIndex=0 then
    rchEditor1.print("Printing")
  Else
    rchEditor2.print("Printing")
  End if
End Sub
'=============================================================================================================
Sub Salir
  Dim resultado as integer
  if rutaArchivo(0)="" and len(rchEditor1.text)>0 then
    resultado=messageDlg(iniLeng.ReadStr("Mensajes Archivos\Nuevo"),iniLeng.ReadStr("Mensajes Archivos\CaptionGuardar"),mbyesno+mbiconquestion)
    if resultado=6 then Call GuardarComo
  end if
  if rutaArchivo(0)<>"" and rchModificado1=True then
    resultado=messageDlg(iniLeng.ReadStr("Mensajes Archivos\Cambios"),iniLeng.ReadStr("Mensajes Archivos\CaptionGuardar"),mbyesno+mbiconquestion)
    if resultado=6 then Call GuardarArchivo
  end if
  if rutaArchivo(1)="" and len(rchEditor2.text)>0 then
    resultado=messageDlg(iniLeng.ReadStr("Mensajes Archivos\Nuevo"),iniLeng.ReadStr("Mensajes Archivos\CaptionGuardar"),mbyesno+mbiconquestion)
    if resultado=6 then Call GuardarComo
  end if
  if rutaArchivo(1)<>"" and rchModificado2=True then
    resultado=messageDlg(iniLeng.ReadStr("Mensajes Archivos\Cambios"),iniLeng.ReadStr("Mensajes Archivos\CaptionGuardar"),mbyesno+mbiconquestion)
    if resultado=6 then Call GuardarArchivo
  end if
  appAplicacion.terminate
End Sub
'=============================================================================================================
Sub Deshacer
  if tabEditor.tabIndex=0 then
    rchEditor1.undo
    rchModificado1=True
  else
    rchEditor2.undo
    rchModificado2=True
  End if
End sub
'=============================================================================================================
Sub Cortar
  if tabEditor.tabIndex=0 then
    rchEditor1.cutToClipboard
    rchModificado1=True
  else
    rchEditor2.cutToClipboard
    rchModificado2=True
  End if
End Sub
'============================================================================================================
Sub Copiar
  if tabEditor.tabIndex=0 then rchEditor1.copyToClipboard  else rchEditor2.copyToClipboard
End sub
'=============================================================================================================
Sub pegar
  Dim numeros as boolean,a as integer
  rchtemporal.pastefromclipboard
  if tabEditor.tabIndex=0 then
    lineaInicial=rcheditor1.row
    lineaFinal=lineaInicial+rchTemporal.linecount-1
    if len(rcheditor1)=0 then numeros=True
    rchEditor1.seltext=rchtemporal.text
    rchtemporal.clear
    rchModificado1=True
    rchNumeracion1.clear
    if numeros=True then
      For a=1 to rchEditor1.linecount
        rchnumeracion1.text= rchnumeracion1.text+str$(a)+crlf
      next a
      numeros=false
    end if
    call coloreaFragmento
  else
    lineaInicial=rcheditor2.row
    lineaFinal=lineaInicial+rchTemporal.linecount-1
    if len(rcheditor2)=0 then numeros=True
    rchEditor2.seltext=rchtemporal.text
    rchtemporal.clear
    rchModificado2=True
    rchNumeracion2.clear
    if numeros=True then
      For a=1 to rchEditor2.linecount
        rchnumeracion2.text= rchnumeracion2.text+str$(a)+crlf
      next a
      numeros=false
    end if
    call coloreaFragmento
  End if
End Sub
'=============================================================================================================
Sub SeleccionarTodo
  if tabEditor.tabIndex=0 then
    rchEditor1.selstart=0
    rchEditor1.sellength=len(rchEditor1.text)

  Else
    rchEditor2.selstart=0
    rchEditor2.sellength=len(rchEditor2.text)
   End if
End Sub

'========================================================================================================================================
Sub Comentar
  Dim i as integer,espacios as integer
  if tabEditor.tabIndex=0 then
    rchtemporal.Text=rchEditor1.seltext
    lineaInicial=rcheditor1.row-rchTemporal.lineCount -1
    LineaFinal=rcheditor1.row
    for i =0 to rchTemporal.lineCount -1
      'Comentar
      if left$(ltrim$(rchTemporal.line(i)),1 ) <> "'" then
        rchTemporal.line(i)="'"+rchTemporal.line(i)
      else 
        'Descomentar
        espacios=instr(rchTemporal.line(i),"'")
        rchTemporal.line(i)=space$(espacios-1)+ Mid$(rchTemporal.line(i), espacios+1, Len(rchTemporal.line(i)))
       end if
    next i
    rcheditor1.seltext=rchTemporal.text
    call coloreaFragmento
    SendMessageAPI.hwnd=rchEditor1.hwnd
    SendMessageAPI.wMsg=EM_HIDESELECTION
    SendMessageAPI.wParam=1
    SendMessageAPI.lParam=0
    SendMessageAPI.execute
    rchTemporal.clear
    rchModificado1=True
  Else
    rchtemporal.Text=rchEditor2.seltext
    lineaInicial=rcheditor2.row-rchTemporal.lineCount -1
    LineaFinal=rcheditor2.row
    for i =0 to rchTemporal.lineCount -1
      if left$(ltrim$(rchTemporal.line(i)),1 ) <> "'" then
        rchTemporal.line(i)="'"+rchTemporal.line(i)
      else 
        espacios=instr(rchTemporal.line(i),"'")
        rchTemporal.line(i)=space$(espacios-1)+ Mid$(rchTemporal.line(i), espacios+1, Len(rchTemporal.line(i)))
       end if
    next i
    rcheditor2.seltext=rchTemporal.text
    call coloreaFragmento
    SendMessageAPI.hwnd=rchEditor2.hwnd
    SendMessageAPI.wMsg=EM_HIDESELECTION
    SendMessageAPI.wParam=1
    SendMessageAPI.lParam=0
    SendMessageAPI.execute
    rchTemporal.clear
    rchModificado1=True
    rchTemporal.clear
    rchModificado2=True
  End if
End sub
'========================================================================================================================================
Sub QuitarLineasVacias
  Dim i as integer
  i=0
  if tabEditor.tabIndex=0 then
    if rcheditor1.SelText <> "" then rchTemporal.text=rchEditor1.Seltext else rchTemporal.text=rchEditor1.text
      while i < rchTemporal.lineCount-1
        if trim$(rchTemporal.line(i)) = "" then rchTemporal.Delline(i) else inc(i)
      wend
    if rchEditor1.SelText <> "" then rchEditor1.seltext=rchtemporal.text  else rchEditor1.text=rchTemporal.text
    rchTemporal.clear
    rchModificado1=True
  Else
    if rcheditor2.SelText <> "" then rchTemporal.text=rchEditor2.Seltext else rchTemporal.text=rchEditor2.text
    do
      if trim$(rchTemporal.line(i)) = "" then rchTemporal.Delline(i) else  inc(i)
    loop until i = rchTemporal.lineCount-1 
    if rchEditor2.SelText <> "" then rchEditor2.seltext=rchtemporal.text  else rchEditor2.text=rchTemporal.text
    rchTemporal.clear
    rchModificado2=True
  End If
end sub 
'=========================================================================================================================================
Sub borrarLinea
  if tabEditor.tabIndex=0 then
    rchEditor1.line(rchEditor1.row)="" 
    rchModificado1=True
  Else
    rchEditor1.line(rchEditor1.row)=""
    rchModificado2=True
  End if
End Sub
'=========================================================================================================================================
Sub AyudaFNX
  With htmlHelpAPI
    hwnd=frmPrincipal.hwnd
    pszFile="fnxbasicHelp.chm"
    execute
  End With
End sub
'========================================================================================================================================
Sub AgregarlineasFavoritas
  Dim i as integer, j as integer
  if tabEditor.tabIndex=0 then
    if lineasFavoritas(0,9)<>"" then
      showmessage iniLeng.readStr("Barras CentroSuperiores\mensajeFavoritos")
      exit sub
    End If
    i=0
    for j= 0 to 9
      if lineasFavoritas(i,j)="" then
        lineasFavoritas(i,j)=trim$(rchEditor1.line(rchEditor1.row))
        cmbFavoritos.additem lineasFavoritas(i,j)
        cmbFavoritos.itemIndex=0
        exit sub
      End if
    next j
  Else
    if lineasFavoritas(1,9)<>"" then
      showmessage iniLeng.readStr("Barras CentroSuperiores\mensajeFavoritos")
      exit sub
    End If
    i=1
    for j= 0 to 9
      if lineasFavoritas(i,j)="" then
        lineasFavoritas(i,j)=trim$(rchEditor2.line(rchEditor2.row))
        cmbFavoritos.additem lineasFavoritas(i,j)
        cmbFavoritos.itemIndex=0
        exit sub
      End if
    next j
  End if
End Sub
'========================================================================================================================================
Sub cambiaFavoritos
  Dim i as integer, j as integer
  cmbFavoritos.clear
  if tabEditor.tabIndex=0 then
    i=0
    for j= 0 to 9
      if lineasFavoritas(i,j)="" then exit for
      cmbFavoritos.additem lineasFavoritas(i,j)
      cmbFavoritos.itemIndex=0
    next j
  Else
    i=1
    for j= 0 to 9
      if lineasFavoritas(i,j)="" then exit for
      cmbFavoritos.additem lineasFavoritas(i,j)
      cmbFavoritos.itemIndex=0
    next j
  End if
End sub

'============================================================================================================
Sub btnBuscar_onclick
  if edtBuscar.text="" then exit sub
  dim lugar as integer,inicio as integer
  if tabEditor.tabIndex=0 then
    if rdoAdelante.checked=True then
      inicio=rchEditor1.selstart+2 
      lugar=instr(Inicio,ucase$(rcheditor1.text),ucase$(edtBuscar.text))
      if lugar>0 then
        rchEditor1.setfocus
        rchEditor1.SelStart=lugar-1
        rchEditor1.scroll
        rchEditor1.Sellength=len(edtBuscar.text)
      end if
    Else
      inicio=rchEditor1.Selstart-1
      lugar=rinstr(inicio,ucase$(rcheditor1.text),ucase$(edtBuscar.text))
      if lugar>0 then
        rchEditor1.setfocus
        rchEditor1.SelStart=lugar-1
        rchEditor1.scroll
        rchEditor1.Sellength=len(edtBuscar.text)
      end if
    End if
  Else
        if rdoAdelante.checked=True then inicio=rchEditor2.selstart+2 else inicio=rchEditor2.Selstart-1
    lugar=instr(Inicio,ucase$(rcheditor2.text),ucase$(edtBuscar.text))
    if lugar>0 then
      rchEditor2.setfocus
      rchEditor2.SelStart=lugar-1
      rchEditor2.scroll
      rchEditor2.Sellength=len(edtBuscar.text)
    else
      ShowMessage iniLeng.readstr("Mensajes Buscar\Noencontrado")

    end if
  End If

End sub
'===========================================================================================================
Sub btnReemplazar_OnClick
  if tabEditor.tabIndex=0 then
    rcheditor1.seltext=edtReemplazar.text
    rchModificado1=True
  Else
   rcheditor2.seltext=edtReemplazar.text
   rchModificado2=True
  End if
End Sub
'===========================================================================================================
Sub Objetos_Onclick(Sender as faceButton)
  Dim Cadena as string
  Dim sangria as integer
  Dim espacios as integer
  Dim LongTab as integer
  LongTab=val(iniConfig.readStr("Tabulador\Espacios"))
  sangria=val(edtsangria.text)
  espacios=LongTab+(longtab*sangria)
  Select case Sender.Tag
    Case 301
      '{Button}
      if tabEditor.tabIndex=0 then
        lineaInicial=rchEditor1.row
        lineaFinal=lineaInicial+12
      else
        lineaInicial=rchEditor2.row
        lineaFinal=lineaInicial+12
      end if
      Cadena=space$(espacios-longTab)+"Object btnButton as Button"+crlf+space$(espacios)+"Tag=0"+crlf+space$(espacios)+"Top=10"+crlf+space$(espacios)+"left=10"+crlf
      Cadena=Cadena+space$(espacios)+"'Width=100"+crlf+space$(espacios)+"'Height=30"+crlf+space$(espacios)+"Caption="+chr$(34)+"Button"+chr$(34)+crlf
      Cadena=cadena+space$(espacios)+"Hint="+chr$(34)+"This is a button"+chr$(34)+crlf+space$(espacios)+"ShowHint=True"+crlf+space$(espacios)+"'Cursor=crHandPoint"+crlf
      Cadena=Cadena+space$(espacios)+"'Bitmap.loadFromFile("+chr$(34)+"bitmap.bmp"+chr$(34)+")"+crlf
      Cadena=Cadena+space$(espacios)+"'OnClick=button_OnClick"+crlf
      Cadena=Cadena+space$(espacios-longTab)+"End Object"
      if tabEditor.tabIndex=0 then
         rchEditor1.SelText=cadena
         rchModificado1=True
         Call coloreaFragmento
         call BuscarObjetos_Onclick
      else 
        rchEditor2.SelText=cadena
        rchModificado2=True
        Call coloreaFragmento
        Call buscarObjetos_onclick
      End If
    Case 302
      '{CheckListBox}
       if tabEditor.tabIndex=0 then
         lineaInicial=rchEditor1.row
         lineaFinal=lineaInicial+8
       else
         lineaInicial=rchEditor2.row
         lineaFinal=lineaInicial+8
      end if
      Cadena=space$(espacios-longTab)+"Object chlCheckListbox as CheckListbox"+crlf+space$(espacios)+"'Align=alClient"+crlf+space$(espacios)+"Top=10"+crlf+space$(espacios)+"left=10"+crlf
      Cadena=Cadena+space$(espacios)+"'Width=200"+crlf+space$(espacios)+"AddItem("+chr$(34)+"Item1"+chr$(34)+")"+crlf+space$(espacios)+"AddItem("+chr$(34)+"Item2"+chr$(34)+")"+crlf
      Cadena=Cadena+space$(espacios)+"'ItemChecked(Index)=True"+crlf
      Cadena=Cadena+space$(espacios-longTab)+"End Object"
      if tabEditor.tabIndex=0 then
         rchEditor1.SelText=cadena
         rchModificado1=True
         Call coloreaFragmento
         call BuscarObjetos_Onclick
      else 
        rchEditor2.SelText=cadena
        rchModificado2=True
        Call coloreaFragmento
        Call buscarObjetos_onclick
      End If

    Case 303
      '{CheckBox}
       if tabEditor.tabIndex=0 then
         lineaInicial=rchEditor1.row
         lineaFinal=lineaInicial+6
       else
         lineaInicial=rchEditor2.row
         lineaFinal=lineaInicial+6
      end if
      Cadena=space$(espacios-longTab)+"Object chkCheckbox as Checkbox"+crlf+space$(espacios)+"Caption="+chr$(34)+"chkCheckbox"+chr$(34)+crlf
      Cadena=Cadena+space$(espacios)+"Top=10"+crlf+space$(espacios)+"left=10"+crlf+space$(espacios)+"'Width=200"+crlf
      Cadena=Cadena+space$(espacios)+"'Checked=True"+crlf
      Cadena=Cadena+space$(espacios-longTab)+"End Object"
      if tabEditor.tabIndex=0 then
         rchEditor1.SelText=cadena
         rchModificado1=True
         Call coloreaFragmento
         call BuscarObjetos_Onclick
      else 
        rchEditor2.SelText=cadena
        rchModificado2=True
        Call coloreaFragmento
        Call buscarObjetos_onclick
      End If

    Case 304
      '{ComboBox}
       if tabEditor.tabIndex=0 then
        lineaInicial=rchEditor1.row
        lineaFinal=lineaInicial+9
      else
        lineaInicial=rchEditor2.row
        lineaFinal=lineaInicial+9
      end if
      Cadena=space$(espacios-longTab)+"Object cmbCombobox as Combobox"+crlf+space$(espacios)+"Top=10"+crlf+space$(espacios)+"left=10"+crlf
      Cadena=Cadena+space$(espacios)+"'Width=200"+crlf+space$(espacios)+"'Sorted=True"+crlf
      Cadena=Cadena+space$(espacios)+"additem("+chr$(34)+"Item1"+chr$(34)+")"+crlf
      Cadena=Cadena+space$(espacios)+"additem("+chr$(34)+"Item2"+chr$(34)+")"+crlf+space$(espacios)+"ItemIndex=0"+crlf
      Cadena=Cadena+space$(espacios)+"'OnClick=cmbCombobox_OnClick"+crlf
      Cadena=Cadena+space$(espacios-longTab)+"End Object"
      if tabEditor.tabIndex=0 then
         rchEditor1.SelText=cadena
         rchModificado1=True
         Call coloreaFragmento
         call BuscarObjetos_Onclick
      else 
        rchEditor2.SelText=cadena
        rchModificado2=True
        Call coloreaFragmento
        Call buscarObjetos_onclick
      End If
    Case 305
      '{DateTimePicker}
      if tabEditor.tabIndex=0 then
        lineaInicial=rchEditor1.row
        lineaFinal=lineaInicial+4
      else
        lineaInicial=rchEditor2.row
        lineaFinal=lineaInicial+4
      end if
      Cadena=space$(espacios-longTab)+"Object dtpDateTimePicker as DateTimePicker"+crlf+space$(espacios)+"Top=10"+crlf+space$(espacios)+"left=10"+crlf
      Cadena=Cadena+space$(espacios)+"'Time=True"+crlf
      Cadena=Cadena+space$(espacios-longTab)+"End Object"
      if tabEditor.tabIndex=0 then
         rchEditor1.SelText=cadena
         rchModificado1=True
         Call coloreaFragmento
         call BuscarObjetos_Onclick
      else 
        rchEditor2.SelText=cadena
        rchModificado2=True
        Call coloreaFragmento
        Call buscarObjetos_onclick
      End If
    Case 306
      '{Edit}
       if tabEditor.tabIndex=0 then
        lineaInicial=rchEditor1.row
        lineaFinal=lineaInicial+8
      else
        lineaInicial=rchEditor2.row
        lineaFinal=lineaInicial+8
      end if
      Cadena=space$(espacios-longTab)+"Object edtEdit as Edit"+crlf+space$(espacios)+"Top=10"+crlf+space$(espacios)+"left=10"+crlf
      Cadena=Cadena+space$(espacios)+"Width=40"+crlf+space$(espacios)+"Height=26"+crlf+space$(espacios)+"'Autoselect=True"+crlf
      Cadena=Cadena+space$(espacios)+"'Passwordchar=True"+crlf+space$(espacios)+"'OnkeyPress=edtEdit_OnkeyPress"+crlf
      Cadena=Cadena+space$(espacios-longTab)+"End Object"
      if tabEditor.tabIndex=0 then
         rchEditor1.SelText=cadena
         rchModificado1=True
         Call coloreaFragmento
         call BuscarObjetos_Onclick
      else 
        rchEditor2.SelText=cadena
        rchModificado2=True
        Call coloreaFragmento
        Call buscarObjetos_onclick
      End If
    Case 307
      '{faceButton}
       if tabEditor.tabIndex=0 then
        lineaInicial=rchEditor1.row
        lineaFinal=lineaInicial+13
      else
        lineaInicial=rchEditor2.row
        lineaFinal=lineaInicial+13
      end if
      Cadena=space$(espacios-longTab)+"Object fceButton as Facebutton"+crlf+space$(espacios)+"Tag=0"+crlf+space$(espacios)+"Top=10"+crlf+space$(espacios)+"left=10"+crlf
      Cadena=Cadena+space$(espacios)+"Width=26"+crlf+space$(espacios)+"Height=26"+crlf+space$(espacios)+"Caption="+chr$(34)+"Facebutton"+chr$(34)+crlf
      Cadena=cadena+space$(espacios)+"Hint="+chr$(34)+"This is a facebutton"+chr$(34)+crlf+space$(espacios)+"ShowHint=True"+crlf+space$(espacios)+"'Cursor=crHandPoint"+crlf
      Cadena=Cadena+space$(espacios)+"Flat=True"+crlf
      Cadena=Cadena+space$(espacios)+"'Bitmap.loadFromFile("+chr$(34)+"bitmap.bmp"+chr$(34)+")"+crlf
      Cadena=Cadena+space$(espacios)+"'OnClick=fcebutton_OnClick"+crlf
      Cadena=Cadena+space$(espacios-longTab)+"End Object"
      if tabEditor.tabIndex=0 then
         rchEditor1.SelText=cadena
         rchModificado1=True
         Call coloreaFragmento
         call BuscarObjetos_Onclick
      else 
        rchEditor2.SelText=cadena
        rchModificado2=True
        Call coloreaFragmento
        Call buscarObjetos_onclick
      End If

    Case 308
      '{Form}
      if tabEditor.tabIndex=0 then
        lineaInicial=rchEditor1.row
        lineaFinal=lineaInicial+13
      else
        lineaInicial=rchEditor2.row
        lineaFinal=lineaInicial+13
      end if
      Cadena=space$(espacios-(longTab*2))+"Object frmForm as Form"+crlf+space$(espacios-longTab)+"Caption="+chr$(34)+"frmForm"+chr$(34)+crlf
      Cadena=Cadena+space$(espacios-longTab)+"Width=640"+crlf+space$(espacios-longTab)+"Height=480"+crlf
      Cadena=Cadena+space$(espacios-longTab)+"Center"+crlf+space$(espacios-longTab)+"'BorderStyle=BsDialog"+crlf
      Cadena=Cadena+space$(espacios-longTab)+"'{Other objects}"+crlf+crlf+space$(espacios-longTab)+"'{End other objects}"+crlf
      Cadena=Cadena+space$(espacios-longTab)+"'Onshow=frmForm_Onshow"+crlf+space$(espacios-longTab)+"'Onclose=frmForm_Onclose"+crlf
      Cadena=Cadena+space$(espacios-(longTab*2))+"End Object"+crlf
      Cadena=Cadena+space$(espacios-(longTab*2))+"'frmForm.WindowState=WsMaximized"+crlf+space$(espacios-(longTab*2))+"frmForm.Showmodal"
      if tabEditor.tabIndex=0 then
         rchEditor1.SelText=cadena
         rchModificado1=True
         Call coloreaFragmento
'         SendMessageAPI.hwnd=rchEditor1.hwnd
'         SendMessageAPI.wMsg=EM_HIDESELECTION
'         SendMessageAPI.wParam=1
'         SendMessageAPI.lParam=0
'         SendMessageAPI.execute
         rchTemporal.clear
         rchModificado1=True
         call BuscarObjetos_Onclick
      else 
        rchEditor2.SelText=cadena
        rchModificado2=True
        Call coloreaFragmento
'        SendMessageAPI.hwnd=rchEditor2.hwnd
'        SendMessageAPI.wMsg=EM_HIDESELECTION
'        SendMessageAPI.wParam=1
'        SendMessageAPI.lParam=0
'        SendMessageAPI.execute
        rchTemporal.clear
        rchModificado1=True
        Call buscarObjetos_Onclick
      End If

    Case 309
    Case 310

  End Select
End sub
'====================================================================================================================
Sub lstSubFun_OnClick(Sender as ListBox)
  Dim ItemCaption as string,lugar as integer
  if tabEditor.tabIndex=0 then
    'sub
    if right$(ucase$(Sender.item(Sender.itemindex)),4)="SUB)" then itemCaption= "Sub" +left$(Sender.item(Sender.ItemIndex),len(Sender.item(Sender.Itemindex))-5)
    lugar=instr(1,ucase$(rchEditor1.text),ucase$(ItemCaption))
    if lugar>0 then
      rchEditor1.setfocus
      rchEditor1.SelStart=lugar-1
      rchEditor1.scroll
      rchEditor1.Sellength=len(itemcaption)
    end if
    'func
    if right$(ucase$(Sender.item(Sender.itemindex)),9)="FUNCTION)" then itemCaption= "Function" +left$(Sender.item(Sender.ItemIndex),len(Sender.item(Sender.Itemindex))-10)
    lugar=instr(1,ucase$(rchEditor1.text),ucase$(ItemCaption))
    if lugar>0 then
      rchEditor1.setfocus
      rchEditor1.SelStart=lugar-1
      rchEditor1.scroll
      rchEditor1.Sellength=len(itemcaption)
    end if

  else
    if right$(ucase$(Sender.item(Sender.itemindex)),4)="SUB)" then itemCaption= "Sub" +left$(Sender.item(Sender.ItemIndex),len(Sender.item(Sender.Itemindex))-5)
    lugar=instr(1,ucase$(rchEditor2.text),ucase$(ItemCaption))
    if lugar>0 then
      rchEditor2.setfocus
      rchEditor2.SelStart=lugar-1
      rchEditor2.scroll
      rchEditor2.Sellength=len(itemcaption)
    end if
    if right$(ucase$(Sender.item(Sender.itemindex)),9)="FUNCTION)" then itemCaption= "Function" +left$(Sender.item(Sender.ItemIndex),len(Sender.item(Sender.Itemindex))-10)
    lugar=instr(1,ucase$(rchEditor2.text),ucase$(ItemCaption))
    if lugar>0 then
      rchEditor2.setfocus
      rchEditor2.SelStart=lugar-1
      rchEditor2.scroll
      rchEditor2.Sellength=len(itemcaption)
    end if

  End if
End sub
'==================================================================================================================
Sub cmbObjetos_Onclick(Sender as ComboBox)
  Dim ItemCaption as string,lugar as integer
  if tabEditor.tabIndex=0 then
    'Objetos
    if right$(ucase$(Sender.item(Sender.itemindex)),4)="DIM)" then itemCaption= "Dim" +left$(Sender.item(Sender.ItemIndex),len(Sender.item(Sender.Itemindex))-5)   else itemCaption= "Object" + Sender.item(Sender.ItemIndex)    
    lugar=instr(1,ucase$(rchEditor1.text),ucase$(ItemCaption))
    if lugar>0 then
      rchEditor1.setfocus
      rchEditor1.SelStart=lugar-1
      rchEditor1.scroll
      rchEditor1.Sellength=len(itemcaption)
    end if
  Else
    'Objetos
    if right$(ucase$(Sender.item(Sender.itemindex)),4)="DIM)" then itemCaption= "Dim" +left$(Sender.item(Sender.ItemIndex),len(Sender.item(Sender.Itemindex))-5)   else itemCaption= "Object" + Sender.item(Sender.ItemIndex)    
    lugar=instr(1,ucase$(rchEditor2.text),ucase$(ItemCaption))
    if lugar>0 then
      rchEditor2.setfocus
      rchEditor2.SelStart=lugar-1
      rchEditor2.scroll
      rchEditor2.Sellength=len(itemcaption)
    end if
  End If
End Sub
'===================================================================================================================
Sub cmbVariables_Onclick(Sender as ComboBox)
  Dim ItemCaption as string,lugar as integer
  if tabEditor.tabIndex=0 then
    'Var
    if right$(ucase$(Sender.item(Sender.itemindex)),4)="DIM)" then itemCaption= "Dim" +left$(Sender.item(Sender.ItemIndex),len(Sender.item(Sender.Itemindex))-5)
    'Const
    if right$(ucase$(Sender.item(Sender.itemindex)),6)="CONST)" then itemCaption= "Const" +left$(Sender.item(Sender.ItemIndex),len(Sender.item(Sender.Itemindex))-7)
    'Record
    if right$(ucase$(Sender.item(Sender.itemindex)),7)="RECORD)" then itemCaption= "Record" +left$(Sender.item(Sender.ItemIndex),len(Sender.item(Sender.Itemindex))-8)
    lugar=instr(1,ucase$(rchEditor1.text),ucase$(ItemCaption))
    if lugar>0 then
      rchEditor1.setfocus
      rchEditor1.SelStart=lugar-1
      rchEditor1.scroll
      rchEditor1.Sellength=len(itemcaption)
    end if
  Else
    'Var
    if right$(ucase$(Sender.item(Sender.itemindex)),4)="DIM)" then itemCaption= "Dim" +left$(Sender.item(Sender.ItemIndex),len(Sender.item(Sender.Itemindex))-5)
    'Const
    if right$(ucase$(Sender.item(Sender.itemindex)),6)="CONST)" then itemCaption= "Const" +left$(Sender.item(Sender.ItemIndex),len(Sender.item(Sender.Itemindex))-7)
    'Record
    if right$(ucase$(Sender.item(Sender.itemindex)),7)="RECORD)" then itemCaption= "Record" +left$(Sender.item(Sender.ItemIndex),len(Sender.item(Sender.Itemindex))-8)
    lugar=instr(1,ucase$(rchEditor2.text),ucase$(ItemCaption))
    if lugar>0 then
      rchEditor2.setfocus
      rchEditor2.SelStart=lugar-1
      rchEditor2.scroll
      rchEditor2.Sellength=len(itemcaption)
    end if
  End If
End Sub
'===================================================================================================================
Sub busquedaRapida_OnClick
  if edtBusquedaRapida.text="" then exit sub
  dim lugar as integer
  if tabEditor.tabIndex=0 then
    lugar=instr(1,ucase$(rcheditor1.text),ucase$(edtBusquedaRapida.text))
    if lugar>0 then
      rchEditor1.setfocus
      rchEditor1.SelStart=lugar-1
      rchEditor1.scroll
      rchEditor1.Sellength=len(edtBusquedaRapida.text)
    else
      ShowMessage iniLeng.readstr("Mensajes Buscar\Noencontrado")
    end if
  Else
    lugar=instr(1,ucase$(rcheditor2.text),ucase$(edtBusquedaRapida.text))
    if lugar>0 then
      rchEditor2.setfocus
      rchEditor2.SelStart=lugar-1
      rchEditor2.scroll
      rchEditor2.Sellength=len(edtBusquedaRapida.text)
    else
      ShowMessage iniLeng.readstr("Mensajes Buscar\Noencontrado")

    end if
  End If
End Sub
'=====================================================================================================================
Sub busquedaRapidaSiguiente_OnClick
  if edtBusquedaRapida.text="" then exit sub
  dim lugar as integer
  if tabEditor.tabIndex=0 then
    lugar=instr(rchEditor1.selstart+2,ucase$(rcheditor1.text),ucase$(edtBusquedaRapida.text))
    if lugar>0 then
      rchEditor1.setfocus
      rchEditor1.SelStart=lugar-1
      rchEditor1.scroll
      rchEditor1.Sellength=len(edtBusquedaRapida.text)
    else
      ShowMessage iniLeng.readstr("Mensajes Buscar\Coincidencias")

    end if
  Else
    lugar=instr(rchEditor2.selstart+2,ucase$(rcheditor2.text),ucase$(edtBusquedaRapida.text))
    if lugar>0 then
      rchEditor2.setfocus
      rchEditor2.SelStart=lugar-1
      rchEditor2.scroll
      rchEditor2.Sellength=len(edtBusquedaRapida.text)
    else
      ShowMessage iniLeng.readstr("Mensajes Buscar\Coincidencias")

    end if
  End If
End Sub

'===================================================================================================================
Sub IrLinea_OnClick
  call irlinea(edtirlinea.text)
End sub
'===================================================================================================================
Sub IrLinea(gotolinea as string)
  Dim caracterIndice as long,linea as integer
  linea=val(gotolinea)-1
  if tabEditor.tabIndex=0 then
    if linea<=0 or linea>rcheditor1.linecount-1 then
      showmessage iniLeng.ReadStr("Mensajes IrLinea\Novalido")

      exit sub
    end if
    SendMessageAPI.hwnd=rchEditor1.hwnd
    SendMessageAPI.wMsg=EM_LINEINDEX
    SendMessageAPI.wParam=linea
    SendMessageAPI.lParam=0
    SendMessageAPI.execute
    caracterIndice=SendmessageAPI.result
    rchEditor1.selstart=caracterIndice
    rcheditor1.setfocus
    rchEditor1.sellength=len(rchEditor1.line(rchEditor1.row))
    rchEditor1.scroll
  else
    if linea<=0 or linea>rcheditor2.linecount-1 then
      showmessage iniLeng.ReadStr("Mensajes IrLinea\Novalido")

      exit sub
    end if
    SendMessageAPI.hwnd=rchEditor2.hwnd
    SendMessageAPI.wMsg=EM_LINEINDEX
    SendMessageAPI.wParam=linea
    SendMessageAPI.lParam=0
    SendMessageAPI.execute
    caracterIndice=SendmessageAPI.result
    rchEditor2.selstart=caracterIndice
    rcheditor2.setfocus
    rchEditor2.sellength=len(rchEditor2.line(rchEditor2.row))
    rchEditor2.scroll
  End if
End Sub
'====================================================================================================================
Sub IrPrimeraLinea_OnClick
  if tabEditor.tabIndex=0 then
    rchEditor1.selstart=0
    rcheditor1.setfocus
    rchEditor1.sellength=len(rchEditor1.line(0))
    rchEditor1.scroll
  else
    rchEditor2.selstart=0
    rcheditor2.setfocus
    rchEditor2.sellength=len(rchEditor2.line(0))
    rchEditor2.scroll
  End If
End Sub
'===================================================================================================================
Sub IrUltimaLinea_OnClick
  Dim caracterIndice as long
  if tabEditor.tabIndex=0 then
    SendMessageAPI.hwnd=rchEditor1.hwnd
    SendMessageAPI.wMsg=EM_LINEINDEX
    SendMessageAPI.wParam=rcheditor1.linecount-1
    SendMessageAPI.lParam=0
    SendMessageAPI.execute
    caracterIndice=SendmessageAPI.result
    rchEditor1.selstart=caracterIndice
    rcheditor1.setfocus
    rchEditor1.sellength=len(rchEditor1.line(rcheditor1.linecount-1))
    rchEditor1.scroll
  else
    SendMessageAPI.hwnd=rchEditor2.hwnd
    SendMessageAPI.wMsg=EM_LINEINDEX
    SendMessageAPI.wParam=rcheditor2.linecount-1
    SendMessageAPI.lParam=0
    SendMessageAPI.execute
    caracterIndice=SendmessageAPI.result
    rchEditor2.selstart=caracterIndice
    rcheditor2.setfocus
    rchEditor2.sellength=len(rchEditor2.line(rcheditor2.linecount-1))
    rchEditor2.scroll
  End If
End Sub
'===================================================================================================================
sub numerarLineas
  Select case tabEditor.tabIndex
    Case 0
        if rchNumeracion1.lineCount<=rchEditor1.linecount then
           rchNumeracion1.Addtext(str$(rchNumeracion1.LineCount+1))
        else
          if rchNumeracion1.LineCount>= rcheditor1.linecount then 
            rchNumeracion1.delline(rchNumeracion1.LineCount-1)
          end if
        End If
    case 1
        if rchNumeracion2.lineCount<=rchEditor2.LineCount then
           rchNumeracion2.Addtext(str$(rchNumeracion2.LineCount+1))
        else
          if rchNumeracion2.LineCount>=rcheditor2.linecount  then 
            rchNumeracion2.delline(rchNumeracion2.LineCount-1)
          end if
        End If
  End select
end sub
'===================================================================================================================
sub tmrNumeracion_Ontimer
  call sincronizaDesplazamiento
End Sub
'===================================================================================================================
Sub sincronizaDesplazamiento
  if tabEditor.tabIndex=0 then
    getscrollPosAPI.hwnd=rcheditor1.hwnd
    getscrollPosAPI.nbar=SB_VERT
    getscrollPosAPI.execute
    with sendmessageAPI
      hwnd=RchNumeracion1.hwnd
      wparam=SB_THUMBPOSITION+&H10000 * getscrollPosAPI.result
      wmsg=WM_VSCROLL
      lparam=0
      execute
    end with
  else
    getscrollPosAPI.hwnd=rcheditor2.hwnd
    getscrollPosAPI.nbar=SB_VERT
    getscrollPosAPI.execute
    with sendmessageAPI
      hwnd=RchNumeracion2.hwnd
      wparam=SB_THUMBPOSITION+&H10000 * getscrollPosAPI.result
      wmsg=WM_VSCROLL
      lparam=0
      execute
    end with
  End If
end sub
'====================================================================================================================
Sub BuscarObjetos_OnClick
  Dim linea as string
  Dim i as integer
  lstSubFun.Clear
  cmbObjetos.Clear
  cmbVariables.Clear
  if tabEditor.tabIndex=0 then
    For i=0 to rchEditor1.linecount-1
      linea=trim$(rchEditor1.line(i))
      'Sub
      if ucase$(left$(linea,4))="SUB " then lstSubFun.additem mid$(linea,4,len(linea)-3)+"("+left$(linea,3)+")"
      'func
      if ucase$(left$(linea,9))="FUNCTION " then lstSubFun.additem mid$(linea,9,len(linea)-8)+"("+left$(linea,8)+")"
      
      'Objetos
      if ucase$(left$(linea,7))="OBJECT " then cmbObjetos.additem mid$(linea,7,len(linea)-6)
      
      'Variables
      if ucase$(left$(linea,4))="DIM " and (ucase$(Right$(linea,4))="LONG" or ucase$(Right$(linea,6))="DOUBLE" or ucase$(Right$(linea,6))="SINGLE" or ucase$(Right$(linea,7))="INTEGER" or ucase$(Right$(linea,6))="STRING" or ucase$(Right$(linea,7))="BOOLEAN" or ucase$(Right$(linea,4))="BYTE" or ucase$(Right$(linea,4))="WORD") then
        cmbVariables.additem mid$(linea,4,len(linea)-3)+"("+left$(linea,3)+")"
        
      End if
      ' Objetos com Dim
      if ucase$(left$(linea,4))="DIM " then
        if  (ucase$(Right$(linea,4))<>"LONG" and  ucase$(Right$(linea,6))<>"DOUBLE" and  ucase$(Right$(linea,6))<>"SINGLE" and  ucase$(Right$(linea,7))<>"INTEGER" and  ucase$(Right$(linea,6))<>"STRING" and  ucase$(Right$(linea,7))<>"BOOLEAN"  and  ucase$(Right$(linea,4))<>"BYTE" and  ucase$(Right$(linea,4))<>"WORD") then
          cmbObjetos.additem mid$(linea,4,len(linea)-3)+"("+left$(linea,3)+")"
        end if
      End if
      'Constantes
       if ucase$(left$(linea,6))="CONST " then cmbVariables.additem mid$(linea,6,len(linea)-5)+"("+left$(linea,5)+")"
      'Record
       if ucase$(left$(linea,7))="RECORD " then cmbVariables.additem mid$(linea,7,len(linea)-6)+"("+left$(linea,6)+")"
      
    next i
    lstSubFun.itemIndex=0
    cmbObjetos.itemIndex=0
    cmbvariables.itemIndex=0
  else
     For i=0 to rchEditor2.linecount-1
      linea=trim$(rchEditor2.line(i))
      if ucase$(left$(linea,4))="SUB " then lstSubFun.additem mid$(linea,4,len(linea)-3)+"("+left$(linea,3)+")"
      if ucase$(left$(linea,9))="FUNCTION " then lstSubFun.additem mid$(linea,9,len(linea)-8)+"("+left$(linea,8)+")"
      lstSubFun.itemIndex=0
      'Objetos
      if ucase$(left$(linea,7))="OBJECT " then cmbObjetos.additem mid$(linea,7,len(linea)-6)
      cmbObjetos.itemIndex=0
      'Variables
      if ucase$(left$(linea,4))="DIM " and (ucase$(Right$(linea,4))="LONG" or ucase$(Right$(linea,6))="DOUBLE" or ucase$(Right$(linea,6))="SINGLE" or ucase$(Right$(linea,7))="INTEGER" or ucase$(Right$(linea,6))="STRING" or ucase$(Right$(linea,7))="BOOLEAN" or ucase$(Right$(linea,4))="BYTE" or ucase$(Right$(linea,4))="WORD") then
        cmbVariables.additem mid$(linea,4,len(linea)-3)+"("+left$(linea,3)+")"
      End if
      ' Objetos com Dim
      if ucase$(left$(linea,4))="DIM " then
        if  (ucase$(Right$(linea,4))<>"LONG" and  ucase$(Right$(linea,6))<>"DOUBLE" and  ucase$(Right$(linea,6))<>"SINGLE" and  ucase$(Right$(linea,7))<>"INTEGER" and  ucase$(Right$(linea,6))<>"STRING" and  ucase$(Right$(linea,7))<>"BOOLEAN"  and  ucase$(Right$(linea,4))<>"BYTE" and  ucase$(Right$(linea,4))<>"WORD") then
          cmbObjetos.additem mid$(linea,4,len(linea)-3)+"("+left$(linea,3)+")"
        end if
      End if
      'Constantes
       if ucase$(left$(linea,6))="CONST " then cmbVariables.additem mid$(linea,6,len(linea)-5)+"("+left$(linea,5)+")"
      'Record
       if ucase$(left$(linea,7))="RECORD " then cmbVariables.additem mid$(linea,7,len(linea)-6)+"("+left$(linea,6)+")"

    next i
    lstSubFun.itemIndex=0
    cmbObjetos.itemIndex=0
    cmbvariables.itemIndex=0
  End If
End sub
'=========================================================================================================================================
Sub cmbFavoritos_OnClick(Sender as ComboBox)
  Dim ItemCaption as string,lugar as integer
  if tabEditor.tabIndex=0 then
  itemCaption=Sender.item(Sender.ItemIndex)
    lugar=instr(1,ucase$(rchEditor1.text),ucase$(ItemCaption))
    if lugar>0 then
      rchEditor1.setfocus
      rchEditor1.SelStart=lugar-1
      rchEditor1.scroll
      rchEditor1.Sellength=len(itemcaption)
    end if
  Else
    'Objetos
    itemCaption=Sender.item(Sender.ItemIndex)
    lugar=instr(1,ucase$(rchEditor2.text),ucase$(ItemCaption))
    if lugar>0 then
      rchEditor2.setfocus
      rchEditor2.SelStart=lugar-1
      rchEditor2.scroll
      rchEditor2.Sellength=len(itemcaption)
    end if
  End If
End Sub